<?php
namespace Internetgalerie\IgsCrm\Domain\Model;

/**
 * CategoryOrganisation
 */
class CategoryOrganisation extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * coName
     *
     * @var string
     */
    protected $coName = '';

    /**
     * limit_to_type
     *
     * @var string
     */
    protected $limitToType = '';

    /**
     * icon
     *
     * @var \TYPO3\CMS\Extbase\Domain\Model\FileReference
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    protected $icon = null;

    /**
     * image
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    protected $image = null;

    
    
    /**
     * Returns the coName
     *
     * @return string $coName
     */
    public function getCoName()
    {
        return $this->coName;
    }

    /**
     * Sets the coName
     *
     * @param string $coName
     * @return void
     */
    public function setCoName($coName)
    {
        $this->coName = $coName;
    }

    /**
     * Returns the limitToType
     *
     * @return string $limitToType
     */
    public function getLimitToType()
    {
        return $this->limitToType;
    }

    /**
     * Sets the limitToType
     *
     * @param string $limitToType
     * @return void
     */
    public function setLimitToType($limitToType)
    {
        $this->limitToType = $limitToType;
    }

    /**
     * Returns the icon
     *
     * @return \TYPO3\CMS\Extbase\Domain\Model\FileReference $icon
     */
    public function getIcon()
    {
        return $this->icon;
    }
    /**
     * Sets the icon
     *
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $icon
     * @return void
     */
    public function setIcon(\TYPO3\CMS\Extbase\Domain\Model\FileReference $icon=null)
    {
        $this->icon = $icon;
    }
    


    /**
     * Adds a FileReference
     *
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $image
     * @return void
     */
    public function addImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $image)
    {
        $this->image->attach($image);
    }

    /**
     * Removes a FileReference
     *
     * @param \TYPO3\CMS\Extbase\Domain\Model\FileReference $imageToRemove The FileReference to be removed
     * @return void
     */
    public function removeImage(\TYPO3\CMS\Extbase\Domain\Model\FileReference $imageToRemove)
    {
        $this->image->detach($imageToRemove);
    }

    /**
     * Returns the image
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\TYPO3\CMS\Extbase\Domain\Model\FileReference> $image
     */
    public function getImage()
    {
        return $this->image;
    }
}
