<?php
namespace Internetgalerie\IgsCrm\Domain\Model;

use Internetgalerie\IgCrmTemplate\Domain\Model\AddressInterface;
use Internetgalerie\IgsCrm\Domain\Repository\ContactContactRepository;
use Internetgalerie\IgDatapoolFe\Domain\Repository\CountryRepository;
use Internetgalerie\IgsCrm\Domain\Model\ContactTag;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Persistence\ObjectStorage;
use Internetgalerie\IgsCrm\Domain\Model\FrontendUser;
use Internetgalerie\IgsCrm\Domain\Model\FrontendUserGroup;


/**
 * Contact
 */
class Contact extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity implements AddressInterface, EntityWithAcl
{

    const MARKER_TITLE = '###TITLE###';
    const MARKER_LASTNAME = '###LASTNAME###';
    const MARKER_FIRSTNAME = '###FIRSTNAME###';
    /**
     * mustReviewed
     *
     * @var boolean
     */
    protected $mustReviewed = false;

    /**
     * type
     *
     * @var string
     */
    protected $type;

  /**
   * tstamp
   *
   * @var integer
   */
    protected $tstamp = 0;

  /**
   * hidden
   *
   * @var bool
   */
    protected $hidden  = 0;
    /**
     * meLastname
     *
     * @var string
     */
    protected $meLastname = '';

    /**
     * meFirstname
     *
     * @var string
     */
    protected $meFirstname = '';

    /**
     * meAddon
     *
     * @var string
     */
    protected $meAddon = '';

    /**
     * addonIntern
     *
     * @var string
     */
    protected $addonIntern = '';

    /**
     * meBriefanrede
     *
     * @var string
     */
    protected $meBriefanrede = '';

    /**
     * meIsFamily
     *
     * @var boolean
     */
    protected $meIsFamily = false;

    /**
     * meFamily
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Person
     */
    protected $meFamily = null;

    /**
     * meInvoiceTo
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Person
     */
    protected $meInvoiceTo = null;

    /**
     * meIsSammelinvoice
     *
     * @var boolean
     */
    protected $meIsSammelinvoice = false;

    /**
     * meAddress
     *
     * @var string
     */
    protected $meAddress = '';

    /**
     * mePobox
     *
     * @var string
     */
    protected $mePobox = '';

    /**
     * meZip
     *
     * @var string
     */
    protected $meZip = '';

    /**
     * meCity
     *
     * @var string
     */
    protected $meCity = '';

    /**
     * meTitleAbrev
     *
     * @var string
     */
    protected $meTitleAbrev = '';

    /**
     * meTitelName
     *
     * @var string
     */
    protected $meTitelName = '';

    /**
     * meTitleTitle
     *
     * @var string
     */
    protected $meTitleTitle = '';

    /**
     * meRemark
     *
     * @var string
     */
    protected $meRemark = '';

    /**
     * meCountryAbrev
     *
     * @var string
     */
    protected $meCountryAbrev = '';

    /**
     * meTitel
     *
     * @var string
     */
    protected $meTitel = '';

    /**
     * meMap
     *
     * @var string
     */
    protected $meMap = '';

    /**
     * meSsmafpersonYear
     *
     * @var integer
     */
    protected $meSsmafpersonYear = 0;

    /**
     * meDiplomName
     *
     * @var string
     */
    protected $meDiplomName = '';

    /**
     * mePatentVorhanden
     *
     * @var boolean
     */
    protected $mePatentVorhanden = false;

    /**
     * mePatentYear
     *
     * @var integer
     */
    protected $mePatentYear;

    /**
     * meCertificates
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\ContactCertificate>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    public $meCertificates = null;

    /**
     * frontendUser
     *
     * @var FrontendUser
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    protected $frontendUser;

    /**
     * meAccount
     *
     * @var string
     */
    protected $meAccount = '';

    /**
     * mePassword
     *
     * @var string
     */
    protected $mePassword = '';

    /**
     * hash
     *
     * @var string
     */
    protected $hash = '';

    /**
     * meAmoid
     *
     * @var integer
     */
    protected $meAmoid = 0;

    /**
     * meAddressid
     *
     * @var integer
     */
    protected $meAddressid = 0;

    /**
     * meTitleNr
     *
     * @var integer
     */
    protected $meTitleNr = 0;

    /**
     * meShortname
     *
     * @var string
     */
    protected $meShortname = '';

    /**
     * meYearOfBirth
     *
     * @var integer
     */
    protected $meYearOfBirth;

    /**
     * meErhaeltInvoice
     *
     * @var boolean
     */
    protected $meErhaeltInvoice = false;

    /**
     * meComment
     *
     * @var string
     */
    protected $meComment = '';

    /**
     * meInvoicesadresse
     *
     * @var integer
     */
    protected $meInvoicesadresse = 0;

    /**
     * meDateOfBirth
     *
     * @var \DateTime
     */
    protected $meDateOfBirth = null;


    /**
     * meVerstorben
     *
     * @var boolean
     */
    protected $meVerstorben = false;

    /**
     * meDiplomJahr
     *
     * @var integer
     */
    protected $meDiplomJahr;

    /**
     * meStatus
     *
     * @var integer
     */
    protected $meStatus = 0;

    /**
     * meMailAlias
     *
     * @var string
     */
    protected $meMailAlias = '';

    /**
     * meMailGeosuisse
     *
     * @var string
     */
    protected $meMailGeosuisse = '';

    /**
     * meMailIgs
     *
     * @var string
     */
    protected $meMailIgs = '';

    /**
     * meExtraFirma
     *
     * @var string
     */
    protected $meExtraFirma = '';

    /**
     * mFirma
     *
     * @var string
     */
    protected $meFirma = '';

    /**
     * mFirmaAddress
     *
     * @var string
     */
    protected $meFirmaAddress = '';

    /**
     * mFirmaZip
     *
     * @var string
     */
    protected $meFirmaZip = '';

    /**
     * mFirmaCity
     *
     * @var string
     */
    protected $meFirmaCity = '';

    /**
     * mFirmaCountryAbrev
     *
     * @var string
     */
    protected $meFirmaCountryAbrev = '';

    /**
     * meEmail
     *
     * @var string
     */
    protected $meEmail = '';

    /**
     * phone
     *
     * @var string
     */
    protected $phone = '';

    /**
     * fax
     *
     * @var string
     */
    protected $fax = '';

    /**
     * meUrl
     *
     * @var string
     */
    protected $meUrl = '';

    /**
     * meImportId
     *
     * @var integer
     */
    protected $meImportId = 0;

    /**
     * meImportSource
     *
     * @var string
     */
    protected $meImportSource = '';

    /**
     * meImportExternalId
     *
     * @var string
     */
    protected $meImportExternalId = '';

    /**
     * extraSorting
     *
     * @var int
     */
    protected $extraSorting = 100;

    /**
     * meExtraText1
     *
     * @var string
     */
    protected $meExtraText1 = '';

    /**
     * meExtraText2
     *
     * @var string
     */
    protected $meExtraText2 = '';

    /**
     * meExtraText3
     *
     * @var string
     */
    protected $meExtraText3 = '';

    /**
     * meExtraText4
     *
     * @var string
     */
    protected $meExtraText4 = '';

    /**
     * meExtraText5
     *
     * @var string
     */
    protected $meExtraText5 = '';



    /**
     * meExtraField1
     *
     * @var string
     */
    protected $meExtraField1 = '';

    /**
     * meExtraField2
     *
     * @var string
     */
    protected $meExtraField2 = '';

    /**
     * meExtraField3
     *
     * @var string
     */
    protected $meExtraField3 = '';



    /**
     * meBildungspass
     *
     * @var boolean
     */
    protected $meBildungspass = false;

    /**
     * meGeosummit
     *
     * @var boolean
     */
    protected $meGeosummit = false;

    /**
     * meNewsletterTest
     *
     * @var boolean
     */
    protected $meNewsletterTest = false;

    /**
     * meStatusOrganisation
     *
     * @var string
     */
    protected $meStatusOrganisation = '';

    /**
     * meTodestag
     *
     * @var \DateTime
     */
    protected $meTodestag = null;




    /**
     * meIsLernende
     *
     * @var boolean
     */
    protected $meIsLernende = false;


    /**
     * meIsBerufsbildner
     *
     * @var boolean
     */
    protected $meIsBerufsbildner = false;

    /**
     * meKlasse
     *
     * @var string
     */
    protected $meKlasse = '';

    /**
     * meExternIdNamespace
     *
     * @var string
     */
    protected $meExternIdNamespace = '';

    /**
     * meExternId
     *
     * @var string
     */
    protected $meExternId = '';

    /**
     * meBmTyp
     *
     * @var string
     */
    protected $meBmTyp = '';

    /**
     * meHeimatort
     *
     * @var string
     */
    protected $meHeimatort = '';

    /**
     * meLbTyp
     *
     * @var string
     */
    protected $meLbTyp = '';

    /**
     * meBranche
     *
     * @var string
     */
    protected $meBranche = '';

    /**
     * Berufsbilder des Lernenden
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Person
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $meBerufsbildner = null;

    /**
     * meAddress2
     *
     * @var string
     */
    protected $meAddress2 = '';

    /**
     * meAddress3
     *
     * @var string
     */
    protected $meAddress3 = '';

    /**
     * meFirmaAddress2
     *
     * @var string
     */
    protected $meFirmaAddress2 = '';

    /**
     * meFirmaAddress3
     *
     * @var string
     */
    protected $meFirmaAddress3 = '';

    /**
     * meOk
     *
     * @var bool
     */
    protected $meOk = false;


    /**
     * meProfession
     *
     * @var string
     */
    protected $meProfession = '';


    /**
     * Kommunikationssprache
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Language
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $meLanguageid = null;

    /**
     * Kommunikationssprache Fallback
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Language
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $fallbackLanguage = null;

    /**
     * meAnredeId
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Anrede
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $meAnredeId = null;

    /**
     * meKantonId
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Kanton
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $meKantonId = null;

    /**
     * mePhoneNumberId
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Phonenumber>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    public $mePhoneNumberId = null;

    /**
     * meEmailaddressId
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Emailaddress>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    public $meEmailaddressId = null;

    /**
     * messages
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Message>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    public $messages = null;



    /**
     * organisationCategory
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\CategoryOrganisation>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $organisationCategory = null;


    /**
     * meTagId
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Tag>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $meTagId = null;



    /**
     * Lehrbetrieb
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Organisation
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $meLehrbetrieb = null;

    /**
     * meContactVerband
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\ContactVerband>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
     public $meContactVerband = null;

    /**
     * contactTag
     *
     * @var ContactTag
     */
    public $contactTag = null;

    /**
     * aclOwner
     *
     * @var int
     */
    public $aclOwner = 0;

    /**
     * aclReadGroups
     *
     * @var ObjectStorage<FrontendUserGroup>
     */
    public $aclReadGroups;

    /**
     * aclWriteGroups
     *
     * @var ObjectStorage<FrontendUserGroup>
     */
    public $aclWriteGroups;

    /**
     * @var array
     */
    protected $contactContactByOrganisation = null;

    /**
     * @var array
     */
    protected $contactContactByContact = null;

    /**
     * @var QueryResultInterface
     */
    protected $country = null;

    /**
     * __construct
     */
    public function __construct()
    {
        $this->aclReadGroups = new ObjectStorage();
        $this->aclWriteGroups = new ObjectStorage();
        //Do not remove the next line: It would break the functionality
        $this->organisationCategory = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->initStorageObjects();
    }

    /**
     * Initializes all ObjectStorage properties
     * Do not modify this method!
     * It will be rewritten on each save in the extension builder
     * You may modify the constructor of this class instead
     *
     * @return void
     */
    protected function initStorageObjects()
    {
        $this->meCertificates = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->mePhoneNumberId = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->meEmailaddressId = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->messages = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->meTagId = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->meContactVerband = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->aclReadGroups = $this->aclReadGroups ?? new ObjectStorage();
        $this->aclWriteGroups = $this->aclWriteGroups ?? new ObjectStorage();
    }


    public function getClass()
    {
        return self::class;
    }
    public function setUid($uid = null)
    {
        return $this->uid = $uid;
    }

    public function setType(string $type): void
    {
        $this->type = $type;
    }
    public function getType()
    {
        return $this->type;
    }
    /*
    public function getArgumentName()
    {
        return strtolower($this->type);
    }
    */
    /**
         * Returns the tstamp
         *
         * @return integer $tstamp
         */
    public function getTstamp()
    {
        return $this->tstamp;
    }


    public function getTstampIso()
    {
        return strftime('%Y-%m-%d %H:%M:%S', $this->tstamp);
    }

    /**
     * Sets the tstamp
     *
     * @param integer $tstamp
     * @return void
     */
    public function setTstamp($tstamp)
    {
        $this->tstamp = $tstamp;
    }
   /**
     * Returns the last change timestamp
     *
     * @return bool $hidden
     */
    public function getHidden() {
      return $this->hidden;
    }
    public function getDisabled() {
      return $this->hidden;
    }

    /**
    * Set the value of Hidden
     *
     * @param bool $hidden
     * @return self
     */
    public function setHidden(bool $hidden)
    {
        $this->hidden = $hidden;
        return $this;
    }

    public function replaceTagName(string $value): string
    {
        return trim(str_replace('  ', ' ', str_replace([self::MARKER_LASTNAME, self::MARKER_FIRSTNAME, self::MARKER_TITLE], [$this->getMeLastname(), $this->getMeFirstname(), $this->getMeTitel()], $value)));
    }
    public function removeTagName(string $value): string
    {
        return trim(str_replace('  ', ' ', str_replace([self::MARKER_LASTNAME, self::MARKER_FIRSTNAME, self::MARKER_TITLE], '', $value)));
    }
    


    /**
     * Returns the meLastname
     *
     * @return string $meLastname
     */
    public function getMeLastname()
    {
        return $this->meLastname;
    }
    public function getLastname()
    {
        return $this->meLastname;
    }


    public function getLastnameFirstname()
    {
        return $this->meLastname.', '.$this->meFirstname;
    }
    public function getLastnameFirstnameSpace()
    {
        return $this->meLastname.' '.$this->meFirstname;
    }

    public function getName()
    {
        if($this->meLastname) {
            return $this->meFirstname . ' ' . $this->meLastname;
        }
        if($this->meFirma) {
            return $this->meFirma;
        }
        return $this->meShortname;
    }

    public function getTitelName()
    {
        if($this->meLastname) {
            return ($this->meTitel ? $this->meTitel . ' ' : '') . $this->meFirstname . ' ' . $this->meLastname;
        }
        if($this->meFirma) {
            return $this->meFirma;
        }
        return $this->meShortname;
    }

    public function getHasAddress()
    {
        if($this->meLastname && $this->meFirstname && $this->meZip && $this->meCity) {
            return true;
        } else {
            return false;
        }
    }
    public function getQrDebitorAdresse()
    {
        return [
                'name' => $this->getName(),
                'address' => $this->getAddress(),
                'zip' => $this->getZip(),
                'city' => $this->getCity(),
                'country' => $this->getCountryPostalCode(),
            ];
    }
   public function getPostalAddress()
    {
        if ($this->getIsOrganisation()) {
            $address[] = $this->getOrganisationName();
            $contactPerson = $this->getContactPerson();
            if ($contactPerson) {
                $address[] = $contactPerson->getAnrede() . ' ' . $contactPerson->getName();
            }
        } else {
            if ($this->getLetterAddressSalutation()) {
                $address[] = $this->getLetterAddressSalutation();
            }
            $address[] = $this->getName();
        }
        if ($this->getAddon()) {
            $address[] = $this->getAddon();
        }
        if ($this->getPoboxText()) {
            $address[] = $this->getPoboxText();
        }
        if ($this->getAddress()) {
            $address[] = $this->getAddress();
        }
        if ($this->getAddress2()) {
            $address[] = $this->getAddress2();
        }
        if ($this->getAddress3()) {
            $address[] = $this->getAddress3();
        }
        $countryPostalCode = $this->getCountryPostalCode();
        if ($countryPostalCode === 'CH' || $countryPostalCode === 'Fl') {
            $countryPostalCode = '';
        }
        $address[] = ($countryPostalCode ? $countryPostalCode . '-' : '') . $this->getZip() . ' ' . $this->getCity();
        $this->postalAddress = implode("\n", $address);
        return $this->postalAddress;
    }
    
    /**
     * Sets the meLastname
     *
     * @param string $meLastname
     * @return void
     */
    public function setMeLastname($meLastname)
    {
        $this->meLastname = $meLastname;
    }

    /**
     * Returns the meFirstname
     *
     * @return string $meFirstname
     */
    public function getMeFirstname()
    {
        return $this->meFirstname;
    }
    public function getFirstname()
    {
        return $this->meFirstname;
    }

    /**
     * Sets the meFirstname
     *
     * @param string $meFirstname
     * @return void
     */
    public function setMeFirstname($meFirstname)
    {
        $this->meFirstname = $meFirstname;
    }

    /**
     * Returns the meAddon
     *
     * @return string $meAddon
     */
    public function getMeAddon()
    {
        return $this->meAddon;
    }
    public function getAddon()
    {
        return $this->meAddon;
    }

    /**
     * Sets the meAddon
     *
     * @param string $meAddon
     * @return void
     */
    public function setMeAddon($meAddon)
    {
        $this->meAddon = $meAddon;
    }


    /**
     * Returns the addonIntern
     *
     * @return string $addonIntern
     */
    public function getAddonIntern()
    {
        return $this->addonIntern;
    }

    /**
     * Sets the addonIntern
     *
     * @param string $addonIntern
     * @return void
     */
    public function setAddonIntern($addonIntern)
    {
        $this->addonIntern = $addonIntern;
    }


    /**
     * Returns the meAddress
     *
     * @return string $meAddress
     */
    public function getMeAddress()
    {
        return $this->meAddress;
    }
    public function getAddress()
    {
        return $this->meAddress;
    }

    /**
     * Sets the meAddress
     *
     * @param string $meAddress
     * @return void
     */
    public function setMeAddress($meAddress)
    {
        $this->meAddress = $meAddress;
    }

    /**
     * Returns the mePobox
     *
     * @return string $mePobox
     */
    public function getMePobox()
    {
        return $this->mePobox;
    }
    public function getPobox()
    {
        return $this->mePobox;
    }
    /**
     * Returns the mePobox
     *
     * @return string $mePobox
     */
    public function getPoboxText()
    {
        if($this->mePobox=='' || $this->mePobox===null) {
            return '';
        }
        return $this->mePobox;
        //return strpos($this->mePobox,' ')>0 || $this->mePobox=='Postfach' ? $this->mePobox : 'Postfach ' . $this->mePobox;
    }

    /**
     * Sets the mePobox
     *
     * @param string $mePobox
     * @return void
     */
    public function setMePobox($mePobox)
    {
        $this->mePobox = $mePobox;
    }

    /**
     * Returns the meZip
     *
     * @return string $meZip
     */
    public function getMeZip()
    {
        return trim($this->meZip);
    }
    public function getZip()
    {
        return trim($this->meZip);
    }

    /**
     * Sets the meZip
     *
     * @param string $meZip
     * @return void
     */
    public function setMeZip($meZip)
    {
        $this->meZip = $meZip;
    }

    /**
     * Returns the meCity
     *
     * @return string $meCity
     */
    public function getMeCity()
    {
        return $this->meCity;
    }
    public function getCity()
    {
        return $this->meCity;
    }

    /**
     * Sets the meCity
     *
     * @param string $meCity
     * @return void
     */
    public function setMeCity($meCity)
    {
        $this->meCity = $meCity;
    }




    /**
     * Returns the meMap
     *
     * @return string $meMap
     */
    public function getMeMap()
    {
        return $this->meMap;
    }
    public function getMap()
    {
        return $this->meMap;
    }

    /**
     * Sets the meMap
     *
     * @param string $meMap
     * @return void
     */
    public function setMeMap($meMap)
    {
        $this->meMap = $meMap;
    }





    
    /**
     * Returns the meTitleAbrev
     *
     * @return string $meTitleAbrev
     */
    public function getMeTitleAbrev()
    {
        return $this->meTitleAbrev;
    }

    /**
     * Sets the meTitleAbrev
     *
     * @param string $meTitleAbrev
     * @return void
     */
    public function setMeTitleAbrev($meTitleAbrev)
    {
        $this->meTitleAbrev = $meTitleAbrev;
    }

    /**
     * Returns the meTitelName
     *
     * @return string $meTitelName
     */
    public function getMeTitelName()
    {
        return $this->meTitelName;
    }

    /**
     * Sets the meTitelName
     *
     * @param string $meTitelName
     * @return void
     */
    public function setMeTitelName($meTitelName)
    {
        $this->meTitelName = $meTitelName;
    }

    /**
     * Returns the meTitleTitle
     *
     * @return string $meTitleTitle
     */
    public function getMeTitleTitle()
    {
        return $this->meTitleTitle;
    }

    /**
     * Sets the meTitleTitle
     *
     * @param string $meTitleTitle
     * @return void
     */
    public function setMeTitleTitle($meTitleTitle)
    {
        $this->meTitleTitle = $meTitleTitle;
    }

    /**
     * Returns the meRemark
     *
     * @return string $meRemark
     */
    public function getMeRemark()
    {
        return $this->meRemark;
    }

    /**
     * Sets the meRemark
     *
     * @param string $meRemark
     * @return void
     */
    public function setMeRemark($meRemark)
    {
        $this->meRemark = $meRemark;
    }

    /**
     * Returns the meCountryAbrev
     *
     * @return string $meCountryAbrev
     */
    public function getMeCountryAbrev()
    {
        return $this->meCountryAbrev;
    }
    /* wie getMeCountryAbrev aber falls nicht definier CH */
    public function getCountryIsoCode()
    {
        return $this->meCountryAbrev ? : 'CH';
    }
    public function getCountryPostalCode()
    {
        if ($this->meCountryAbrev == 'LI') {
            return 'FL';
        }        
        return $this->meCountryAbrev ? : 'CH';
    }
    public function getCountry()
    {
        if ($this->country === null && $this->meCountryAbrev) {
            $countryRepository = GeneralUtility::makeInstance(CountryRepository::class);
            $this->country = $countryRepository->findOneByCnIso_2($this->meCountryAbrev);
        }        
        return $this->country;
    }

    /**
     * Sets the meCountryAbrev
     *
     * @param string $meCountryAbrev
     * @return void
     */
    public function setMeCountryAbrev($meCountryAbrev)
    {
        $this->meCountryAbrev = $meCountryAbrev;
    }

    /**
     * Returns the meTitel
     *
     * @return string $meTitel
     */
    public function getMeTitel()
    {
        return $this->meTitel;
    }

    /**
     * Sets the meTitel
     *
     * @param string $meTitel
     * @return void
     */
    public function setMeTitel($meTitel)
    {
        $this->meTitel = $meTitel;
    }


    /**
     * Returns the meSsmafpersonYear
     *
     * @return integer $meSsmafpersonYear
     */
    public function getMeSsmafpersonYear()
    {
        return $this->meSsmafpersonYear;
    }

    /**
     * Sets the meSsmafpersonYear
     *
     * @param integer $meSsmafpersonYear
     * @return void
     */
    public function setMeSsmafpersonYear($meSsmafpersonYear)
    {
        $this->meSsmafpersonYear = $meSsmafpersonYear;
    }

    /**
     * Returns the meDiplomName
     *
     * @return string $meDiplomName
     */
    public function getMeDiplomName()
    {
        return $this->meDiplomName;
    }

    /**
     * Sets the meDiplomName
     *
     * @param string $meDiplomName
     * @return void
     */
    public function setMeDiplomName($meDiplomName)
    {
        $this->meDiplomName = $meDiplomName;
    }

    /**
     * Returns the mePatentVorhanden
     *
     * @return boolean $mePatentVorhanden
     */
    public function getMePatentVorhanden()
    {
        return $this->mePatentVorhanden;
    }

    /**
     * Sets the mePatentVorhanden
     *
     * @param boolean $mePatentVorhanden
     * @return void
     */
    public function setMePatentVorhanden($mePatentVorhanden)
    {
        $this->mePatentVorhanden = $mePatentVorhanden;
    }

    /**
     * Returns the boolean state of mePatentVorhanden
     *
     * @return boolean
     */
    public function isMePatentVorhanden()
    {
        return $this->mePatentVorhanden;
    }

    /**
     * Returns the mePatentYear
     *
     * @return integer $mePatentYear
     */
    public function getMePatentYear()
    {
        return $this->mePatentYear;
    }

    /**
     * Sets the mePatentYear
     *
     * @param integer $mePatentYear
     * @return void
     */
    public function setMePatentYear($mePatentYear)
    {
        $this->mePatentYear = $mePatentYear;
    }

    /**
     * Adds a Certificate
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\ContactCertificate $meCertificate
     * @return void
     */
    public function addMeCertificate(\Internetgalerie\IgsCrm\Domain\Model\ContactCertificate $meCertificate)
    {
        $this->meCertificates->attach($meCertificate);
    }

    /**
     * Removes a Certificate
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\ContactCertificate $meCertificateToRemove The Certificate to be removed
     * @return void
     */
    public function removeMeCertificate(\Internetgalerie\IgsCrm\Domain\Model\ContactCertificate $meCertificateToRemove)
    {
        $this->meCertificates->detach($meCertificateToRemove);
    }

    /**
     * Returns the meCertificates
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\ContactCertificate> $meCertificates
     */
    public function getMeCertificates()
    {
        return $this->meCertificates;
    }


    /**
     * Sets the meCertificates
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\ContactCertificate> $meCertificates
     * @return void
     */
    public function setMeCertificates(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $meCertificates)
    {
        $this->meCertificates = $meCertificates;
    }
    
    /**
     * Returns the frontendUser
     *
     * @return FrontendUser $frontendUser
     */
    public function getFrontendUser()
    {
        if ($this->frontendUser instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->frontendUser = $this->frontendUser->_loadRealInstance();
        }
        return $this->frontendUser;
    }

    /**
     * Sets the frontendUser
     *
     * @param FrontendUser $frontendUser
     * @return void
     */
    public function setFrontendUser(FrontendUser $frontendUser)
    {
        $this->frontendUser = $frontendUser;
    }

    /**
     * Returns the meAccount
     *
     * @return string $meAccount
     */
    public function getMeAccount()
    {
        return $this->meAccount;
    }

    /**
     * Sets the meAccount
     *
     * @param string $meAccount
     * @return void
     */
    public function setMeAccount($meAccount)
    {
        $this->meAccount = $meAccount;
    }

    /**
     * Returns the mePassword
     *
     * @return string $mePassword
     */
    public function getMePassword()
    {
        return $this->mePassword;
    }

    /**
     * Sets the mePassword
     *
     * @param string $mePassword
     * @return void
     */
    public function setMePassword($mePassword)
    {
        $this->mePassword = $mePassword;
    }


    /**
     * Returns the meAmoid
     *
     * @return integer $meAmoid
     */
    public function getMeAmoid()
    {
        return $this->meAmoid > 0 ? $this->meAmoid : '';
    }

    /**
     * Sets the meAmoid
     *
     * @param integer $meAmoid
     * @return void
     */
    public function setMeAmoid($meAmoid)
    {
        $this->meAmoid = $meAmoid;
    }

    /**
     * Returns the meAddressid
     *
     * @return integer $meAddressid
     */
    public function getMeAddressidForLetter($depth=3)
    {
        if ($depth==0) {
            die('too much recursion on meInvoiceTo or meFamily. Current: ' . $this->meAddressid .' (' . $this->meLastname . ' ' . $this->meFirstname . ')' );
        }
        if ($this->meInvoiceTo!==null) {
            return $this->meInvoiceTo->getMeAddressidForLetter($depth-1);
        }
        if ($this->meFamily!==null) {
            return $this->meFamily->getMeAddressidForLetter($depth-1);
        }
        return $this->meAddressid;
    }
    /**
     * Returns the meAddressid
     *
     * @return integer $meAddressid
     */
    public function getMeAddressid()
    {
        return $this->meAddressid;
    }
    public function getOwnNumber()
    {
        return $this->meAddressid;
    }
    public function getNumber()
    {
        return $this->meAddressid;
        //        return $this->uid;
        //return $this->meAddressid;
    }

    /**
     * Sets the meAddressid
     *
     * @param integer $meAddressid
     * @return void
     */
    public function setMeAddressid($meAddressid)
    {
        $this->meAddressid = $meAddressid;
    }

    /**
     * Returns the meTitleNr
     *
     * @return integer $meTitleNr
     */
    public function getMeTitleNr()
    {
        return $this->meTitleNr;
    }

    /**
     * Sets the meTitleNr
     *
     * @param integer $meTitleNr
     * @return void
     */
    public function setMeTitleNr($meTitleNr)
    {
        $this->meTitleNr = $meTitleNr;
    }

    /**
     * Returns the meShortname
     *
     * @return string $meShortname
     */
    public function getMeShortname()
    {
        return $this->meShortname;
    }
    public function getShortname()
    {
        return $this->meShortname;
    }

    /**
     * Sets the meShortname
     *
     * @param string $meShortname
     * @return void
     */
    public function setMeShortname($meShortname)
    {
        $this->meShortname = $meShortname;
    }

    /**
     * Returns the meYearOfBirth
     *
     * @return integer $meYearOfBirth
     */
    public function getMeYearOfBirth()
    {
        if($this->meDateOfBirth!==null) {
            return $this->meDateOfBirth->format('Y');
        }
        return $this->meYearOfBirth;
    }

    /**
     * Sets the meYearOfBirth
     *
     * @param integer $meYearOfBirth
     * @return void
     */
    public function setMeYearOfBirth($meYearOfBirth)
    {
        $this->meYearOfBirth = $meYearOfBirth;
    }

    /**
     * Returns the meErhaeltInvoice
     *
     * @return boolean $meErhaeltInvoice
     */
    public function getMeErhaeltInvoice()
    {
        return $this->meErhaeltInvoice;
    }

    /**
     * Sets the meErhaeltInvoice
     *
     * @param boolean $meErhaeltInvoice
     * @return void
     */
    public function setMeErhaeltInvoice($meErhaeltInvoice)
    {
        $this->meErhaeltInvoice = $meErhaeltInvoice;
    }

    /**
     * Returns the boolean state of meErhaeltInvoice
     *
     * @return boolean
     */
    public function isMeErhaeltInvoice()
    {
        return $this->meErhaeltInvoice;
    }

    /**
     * Returns the meComment
     *
     * @return string $meComment
     */
    public function getMeComment()
    {
        return $this->meComment;
    }

    /**
     * Sets the meComment
     *
     * @param string $meComment
     * @return void
     */
    public function setMeComment($meComment)
    {
        $this->meComment = $meComment;
    }

    /**
     * Returns the meInvoicesadresse
     *
     * @return integer $meInvoicesadresse
     */
    public function getMeInvoicesadresse()
    {
        return $this->meInvoicesadresse;
    }

    /**
     * Sets the meInvoicesadresse
     *
     * @param integer $meInvoicesadresse
     * @return void
     */
    public function setMeInvoicesadresse($meInvoicesadresse)
    {
        $this->meInvoicesadresse = $meInvoicesadresse;
    }

    /**
     * Returns the meDateOfBirth
     *
     * @return \DateTime $meDateOfBirth
     */
    public function getMeDateOfBirth()
    {
        return $this->meDateOfBirth;
    }

    /**
     * Sets the meDateOfBirth
     *
     * @param \DateTime $meDateOfBirth
     * @return void
     */
    public function setMeDateOfBirth($meDateOfBirth)
    {
        $this->meDateOfBirth = $meDateOfBirth;
    }





    /**
     * Returns the meVerstorben
     *
     * @return boolean $meVerstorben
     */
    public function getMeVerstorben()
    {
        return $this->meVerstorben;
    }

    /**
     * Sets the meVerstorben
     *
     * @param boolean $meVerstorben
     * @return void
     */
    public function setMeVerstorben($meVerstorben)
    {
        $this->meVerstorben = $meVerstorben;
    }

    /**
     * Returns the boolean state of meVerstorben
     *
     * @return boolean
     */
    public function isMeVerstorben()
    {
        return $this->meVerstorben;
    }




    /**
     * Returns the meDiplomJahr
     *
     * @return integer $meDiplomJahr
     */
    public function getMeDiplomJahr()
    {
        return $this->meDiplomJahr;
    }

    /**
     * Sets the meDiplomJahr
     *
     * @param integer $meDiplomJahr
     * @return void
     */
    public function setMeDiplomJahr($meDiplomJahr)
    {
        $this->meDiplomJahr = $meDiplomJahr;
    }

    /**
     * Returns the meStatus
     *
     * @return integer $meStatus
     */
    public function getMeStatus()
    {
        return $this->meStatus;
    }

    /**
     * Sets the meStatus
     *
     * @param integer $meStatus
     * @return void
     */
    public function setMeStatus($meStatus)
    {
        $this->meStatus = $meStatus;
    }

    /**
     * Returns the meTodestag
     *
     * @return \DateTime $meTodestag
     */
    public function getMeTodestag()
    {
        return $this->meTodestag;
    }
    public function getActive()
    {
        $now = new \DateTime;
        return $this->hidden == 0 && ($this->meTodestag === null || $this->meTodestag > $now) && $this->meVerstorben !== true;
    }

    /**
     * Sets the meTodestag
     *
     * @param \DateTime $meTodestag
     * @return void
     */

    public function setMeTodestag($meTodestag)
    {
        $this->meTodestag = $meTodestag;
    }


    /**
     * Returns the meStatusOrganisation
     *
     * @return string $meStatusOrganisation
     */
    public function getMeStatusOrganisation()
    {
        return $this->meStatusOrganisation;
    }

    /**
     * Sets the meStatusOrganisation
     *
     * @param string $meStatusOrganisation
     * @return void
     */
    public function setMeStatusOrganisation($meStatusOrganisation)
    {
        $this->meStatusOrganisation = $meStatusOrganisation;
    }

    /**
     * Returns the meMailAlias
     *
     * @return string $meMailAlias
     */
    public function getMeMailAlias()
    {
        return $this->meMailAlias;
    }

    /**
     * Sets the meMailAlias
     *
     * @param string $meMailAlias
     * @return void
     */
    public function setMeMailAlias($meMailAlias)
    {
        $this->meMailAlias = $meMailAlias;
    }

    /**
     * Returns the meMailGeosuisse
     *
     * @return string $meMailGeosuisse
     */
    public function getMeMailGeosuisse()
    {
        return $this->meMailGeosuisse;
    }

    /**
     * Sets the meMailGeosuisse
     *
     * @param string $meMailGeosuisse
     * @return void
     */
    public function setMeMailGeosuisse($meMailGeosuisse)
    {
        $this->meMailGeosuisse = $meMailGeosuisse;
    }

    /**
     * Returns the meMailIgs
     *
     * @return string $meMailIgs
     */
    public function getMeMailIgs()
    {
        return $this->meMailIgs;
    }

    /**
     * Sets the meMailIgs
     *
     * @param string $meMailIgs
     * @return void
     */
    public function setMeMailIgs($meMailIgs)
    {
        $this->meMailIgs = $meMailIgs;
    }

    /**
     * Returns the meExtraFirma
     *
     * @return string $meExtraFirma
     */
    public function getMeExtraFirma()
    {
        return $this->meExtraFirma;
    }

    /**
     * Sets the meExtraFirma
     *
     * @param string $meExtraFirma
     * @return void
     */
    public function setMeExtraFirma($meExtraFirma)
    {
        $this->meExtraFirma = $meExtraFirma;
    }

    /**
     * Returns the meFirma
     *
     * @return string $meFirma
     */
    public function getMeFirma()
    {
        return $this->meFirma;
    }

    /**
     * Sets the meFirma
     *
     * @param string $meFirma
     * @return void
     */
    public function setMeFirma($meFirma)
    {
        $this->meFirma = $meFirma;
    }









    /**
     * Returns the meFirmaAddress
     *
     * @return string $meFirmaAddress
     */
    public function getMeFirmaAddress()
    {
        return $this->meFirmaAddress;
    }

    /**
     * Sets the meFirmaAddress
     *
     * @param string $meFirmaAddress
     * @return void
     */
    public function setMeFirmaAddress($meFirmaAddress)
    {
        $this->meFirmaAddress = $meFirmaAddress;
    }

    /**
     * Returns the meFirmaZip
     *
     * @return string $meFirmaZip
     */
    public function getMeFirmaZip()
    {
        return $this->meFirmaZip;
    }

    /**
     * Sets the meFirmaZip
     *
     * @param string $meFirmaZip
     * @return void
     */
    public function setMeFirmaZip($meFirmaZip)
    {
        $this->meFirmaZip = $meFirmaZip;
    }

    /**
     * Returns the meFirmaCity
     *
     * @return string $meFirmaCity
     */
    public function getMeFirmaCity()
    {
        return $this->meFirmaCity;
    }

    /**
     * Sets the meFirmaCity
     *
     * @param string $meFirmaCity
     * @return void
     */
    public function setMeFirmaCity($meFirmaCity)
    {
        $this->meFirmaCity = $meFirmaCity;
    }

    /**
     * Returns the meFirmaCountryAbrev
     *
     * @return string $meFirmaCountryAbrev
     */
    public function getMeFirmaCountryAbrev()
    {
        return $this->meFirmaCountryAbrev;
    }

    /**
     * Sets the meFirmaCountryAbrev
     *
     * @param string $meFirmaCountryAbrev
     * @return void
     */
    public function setMeFirmaCountryAbrev($meFirmaCountryAbrev)
    {
        $this->meFirmaCountryAbrev = $meFirmaCountryAbrev;
    }







    /**
     * Returns the meEmail
     *
     * @return string $meEmail
     */
    public function getMeEmail()
    {
        return $this->meEmail;
    }

    /**
     * Sets the meEmail
     *
     * @param string $meEmail
     * @return void
     */
    public function setMeEmail($meEmail)
    {
        $this->meEmail = $meEmail;
    }

    /**
     * Returns the phone
     *
     * @return string $phone
     */
    public function getPhone()
    {
        return $this->phone;
    }

    /**
     * Sets the phone
     *
     * @param string $phone
     * @return void
     */
    public function setPhone($phone)
    {
        $this->phone = $phone;
    }

    /**
     * Returns the fax
     *
     * @return string $fax
     */
    public function getFax()
    {
        return $this->fax;
    }

    /**
     * Sets the fax
     *
     * @param string $fax
     * @return void
     */
    public function setFax($fax)
    {
        $this->fax = $fax;
    }

    /**
     * Returns the meUrl
     *
     * @return string $meUrl
     */
    public function getMeUrl()
    {
        return $this->meUrl;
    }

    /**
     * Sets the meUrl
     *
     * @param string $meUrl
     * @return void
     */
    public function setMeUrl($meUrl)
    {
        $this->meUrl = $meUrl;
    }

    /**
     * Returns the meImportId
     *
     * @return int $meImportId
     */
    public function getMeImportId()
    {
        return $this->meImportId;
    }

    /**
     * Sets the meImportId
     *
     * @param int $meImportId
     * @return void
     */
    public function setMeImportId($meImportId)
    {
        $this->meImportId = $meImportId;
    }

    /**
     * Returns the meImportSource
     *
     * @return string $meImportSource
     */
    public function getMeImportSource()
    {
        return $this->meImportSource;
    }

    /**
     * Sets the meImportSource
     *
     * @param string $meImportSource
     * @return void
     */
    public function setMeImportSource($meImportSource)
    {
        $this->meImportSource = $meImportSource;
    }

    /**
     * Returns the meImportExternalId
     *
     * @return string $meImportExternalId
     */
    public function getMeImportExternalId()
    {
        return $this->meImportExternalId;
    }

    /**
     * Sets the meImportExternalId
     *
     * @param string $meImportExternalId
     * @return void
     */
    public function setMeImportExternalId($meImportExternalId)
    {
        $this->meImportExternalId = $meImportExternalId;
    }


    /**
     * Returns the extraSorting
     *
     * @return integer $extraSorting
     */
    public function getExtraSorting() {
        return $this->extraSorting;
    }

    /**
     * Sets the extraSorting
     *
     * @param integer $extraSorting
     * @return void
     */
    public function setExtraSorting($extraSorting) {
        $this->extraSorting = $extraSorting;
    }

    /**
     * Returns the meExtraText1
     *
     * @return string $meExtraText1
     */
    public function getMeExtraText1()
    {
        return $this->meExtraText1;
    }

    /**
     * Sets the meExtraText1
     *
     * @param string $meExtraText1
     * @return void
     */
    public function setMeExtraText1($meExtraText1)
    {
        $this->meExtraText1 = $meExtraText1;
    }


    /**
     * Returns the meExtraText2
     *
     * @return string $meExtraText2
     */
    public function getMeExtraText2()
    {
        return $this->meExtraText2;
    }

    /**
     * Sets the meExtraText2
     *
     * @param string $meExtraText2
     * @return void
     */
    public function setMeExtraText2($meExtraText2)
    {
        $this->meExtraText2 = $meExtraText2;
    }


    /**
     * Returns the meExtraText3
     *
     * @return string $meExtraText3
     */
    public function getMeExtraText3()
    {
        return $this->meExtraText3;
    }

    /**
     * Sets the meExtraText3
     *
     * @param string $meExtraText3
     * @return void
     */
    public function setMeExtraText3($meExtraText3)
    {
        $this->meExtraText3 = $meExtraText3;
    }

    /**
     * Returns the meExtraText4
     *
     * @return string $meExtraText4
     */
    public function getMeExtraText4()
    {
        return $this->meExtraText4;
    }

    /**
     * Sets the meExtraText4
     *
     * @param string $meExtraText4
     * @return void
     */
    public function setMeExtraText4($meExtraText4)
    {
        $this->meExtraText4 = $meExtraText4;
    }


    /**
     * Returns the meExtraText5
     *
     * @return string $meExtraText5
     */
    public function getMeExtraText5()
    {
        return $this->meExtraText5;
    }

    /**
     * Sets the meExtraText5
     *
     * @param string $meExtraText5
     * @return void
     */
    public function setMeExtraText5($meExtraText5)
    {
        $this->meExtraText5 = $meExtraText5;
    }




    /**
     * Returns the meExtraField1
     *
     * @return string $meExtraField1
     */
    public function getMeExtraField1()
    {
        return $this->meExtraField1;
    }

    /**
     * Sets the meExtraField1
     *
     * @param string $meExtraField1
     * @return void
     */
    public function setMeExtraField1($meExtraField1)
    {
        $this->meExtraField1 = $meExtraField1;
    }


    /**
     * Returns the meExtraField2
     *
     * @return string $meExtraField2
     */
    public function getMeExtraField2()
    {
        return $this->meExtraField2;
    }

    /**
     * Sets the meExtraField2
     *
     * @param string $meExtraField2
     * @return void
     */
    public function setMeExtraField2($meExtraField2)
    {
        $this->meExtraField2 = $meExtraField2;
    }


    /**
     * Returns the meExtraField3
     *
     * @return string $meExtraField3
     */
    public function getMeExtraField3()
    {
        return $this->meExtraField3;
    }

    /**
     * Sets the meExtraField3
     *
     * @param string $meExtraField3
     * @return void
     */
    public function setMeExtraField3($meExtraField3)
    {
        $this->meExtraField3 = $meExtraField3;
    }





    /**
     * Returns the meBildungspass
     *
     * @return boolean $meBildungspass
     */
    public function getMeBildungspass()
    {
        return $this->meBildungspass;
    }

    /**
     * Sets the meBildungspass
     *
     * @param boolean $meBildungspass
     * @return void
     */
    public function setMeBildungspass($meBildungspass)
    {
        $this->meBildungspass = $meBildungspass;
    }

    /**
     * Returns the boolean state of meBildungspass
     *
     * @return boolean
     */
    public function isMeBildungspass()
    {
        return $this->meBildungspass;
    }

    /**
     * Returns the meGeosummit
     *
     * @return boolean $meGeosummit
     */
    public function getMeGeosummit()
    {
        return $this->meGeosummit;
    }

    /**
     * Sets the meGeosummit
     *
     * @param boolean $meGeosummit
     * @return void
     */
    public function setMeGeosummit($meGeosummit)
    {
        $this->meGeosummit = $meGeosummit;
    }

    /**
     * Returns the boolean state of meGeosummit
     *
     * @return boolean
     */
    public function isMeGeosummit()
    {
        return $this->meGeosummit;
    }





    /**
     * Returns the meNewsletterTest
     *
     * @return boolean $meNewsletterTest
     */
    public function getMeNewsletterTest()
    {
        return $this->meNewsletterTest;
    }

    /**
     * Sets the meNewsletterTest
     *
     * @param boolean $meNewsletterTest
     * @return void
     */
    public function setMeNewsletterTest($meNewsletterTest)
    {
        $this->meNewsletterTest = $meNewsletterTest;
    }

    /**
     * Returns the boolean state of meNewsletterTest
     *
     * @return boolean
     */
    public function isMeNewsletterTest()
    {
        return $this->meNewsletterTest;
    }


    /**
     * Returns the meAddress2
     *
     * @return string $meAddress2
     */
    public function getMeAddress2()
    {
        return $this->meAddress2;
    }
    public function getAddress2()
    {
        return $this->meAddress2;
    }

    /**
     * Sets the meAddress2
     *
     * @param string $meAddress2
     * @return void
     */
    public function setMeAddress2($meAddress2)
    {
        $this->meAddress2 = $meAddress2;
    }

    /**
     * Returns the meAddress3
     *
     * @return string $meAddress3
     */
    public function getMeAddress3()
    {
        return $this->meAddress3;
    }
    public function getAddress3()
    {
        return $this->meAddress3;
    }

    /**
     * Sets the meAddress3
     *
     * @param string $meAddress3
     * @return void
     */
    public function setMeAddress3($meAddress3)
    {
        $this->meAddress3 = $meAddress3;
    }

    /**
     * Returns the meFirmaAddress2
     *
     * @return string $meFirmaAddress2
     */
    public function getMeFirmaAddress2()
    {
        return $this->meFirmaAddress2;
    }

    /**
     * Sets the meFirmaAddress2
     *
     * @param string $meFirmaAddress2
     * @return void
     */
    public function setMeFirmaAddress2($meFirmaAddress2)
    {
        $this->meFirmaAddress2 = $meFirmaAddress2;
    }

    /**
     * Returns the meFirmaAddress3
     *
     * @return string $meFirmaAddress3
     */
    public function getMeFirmaAddress3()
    {
        return $this->meFirmaAddress3;
    }

    /**
     * Sets the meFirmaAddress3
     *
     * @param string $meFirmaAddress3
     * @return void
     */
    public function setMeFirmaAddress3($meFirmaAddress3)
    {
        $this->meFirmaAddress3 = $meFirmaAddress3;
    }

    /**
     * Returns the meOk
     *
     * @return bool $meOk
     */
    public function getMeOk()
    {
        return $this->meOk;
    }

    /**
     * Sets the meOk
     *
     * @param bool $meOk
     * @return void
     */
    public function setMeOk($meOk)
    {
        $this->meOk = $meOk;
    }

    /**
     * Returns the boolean state of meOk
     *
     * @return bool
     */
    public function isMeOk()
    {
        return $this->meOk;
    }

    /**
     * Returns the meProfession
     *
     * @return string $meProfession
     */
    public function getMeProfession()
    {
        return $this->meProfession;
    }

    /**
     * Sets the meProfession
     *
     * @param string $meProfession
     * @return void
     */
    public function setMeProfession($meProfession)
    {
        $this->meProfession = $meProfession;
    }


    /**
     * Returns the meBerufsbildner
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Person $meBerufsbildner
     */
    public function getMeBerufsbildner()
    {
        return $this->meBerufsbildner;
    }

    /**
     * Sets the meBerufsbildner
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Person $meBerufsbildner
     * @return void
     */
    public function setMeBerufsbildner(\Internetgalerie\IgsCrm\Domain\Model\Person $meBerufsbildner=null)
    {
        $this->meBerufsbildner = $meBerufsbildner;
    }

    /**
     * Returns the lernende (persons with meBerufsbildner=my.uid)
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Person $lernende
     */
    public function getLernende()
    {
        $personRepository = GeneralUtility::makeInstance(\Internetgalerie\IgsCrm\Domain\Repository\PersonRepository::class);
        return $personRepository->findByMeBerufsbildner($this->uid);
    }


    /**
     * Returns the meLanguageid
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Language $meLanguageid
     */
    public function getMeLanguageid()
    {
        if ($this->meLanguageid instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->meLanguageid = $this->meLanguageid->_loadRealInstance();
        }
        return $this->meLanguageid;
    }
    public function getLanguageCode()
    {
        $meLanguageid= $this->getMeLanguageid();
        if ($meLanguageid instanceof \Internetgalerie\IgsCrm\Domain\Model\Language) {
            return $meLanguageid->getCode();
        }
        return 'de';
    }
    public function getLanguageCodeWithFallback(array $allowedLanguages = ['de', 'fr'])
    {
        $language = $this->getLanguageWithFallback($allowedLanguages);
        if ($language instanceof \Internetgalerie\IgsCrm\Domain\Model\Language) {
            return $language->getCode();
        }
        return $allowedLanguages[0] ?? 'de';
    }
    
    public function getLanguageShort()
    {
        $meLanguageid= $this->getMeLanguageid();
        if ($meLanguageid instanceof \Internetgalerie\IgsCrm\Domain\Model\Language) {
            return $meLanguageid->getShort();
        }
        return 'D';
    }
    public function getLanguage()
    {
        return $this->getMeLanguageid();
    }
    public function getLanguageWithFallback(array $languages)
    {
        $language = $this->getMeLanguageid();
        if ($language instanceof \Internetgalerie\IgsCrm\Domain\Model\Language) {
            if (in_array($language->getCode(), $languages)) {
                return $language;
            }
        }
        return $this->getFallbackLanguage() ?? $language;
    }
    public function getLanguageLocale()
    {
        $meLanguageid= $this->getMeLanguageid();
        if ($meLanguageid instanceof \Internetgalerie\IgsCrm\Domain\Model\Language) {
            return $meLanguageid->getLgLocale();
        }
        return '';
    }
    /**
     * Returns the meLanguage
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Language $meLanguageid
     */
    public function getMeLanguage()
    {
        return $this->getLanguageCode();//$this->meLanguageid->getLgShort();
    }

    /**
     * Sets the meLanguageid
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Language $meLanguageid
     * @return void
     */
    public function setMeLanguageid(\Internetgalerie\IgsCrm\Domain\Model\Language $meLanguageid = null)
    {
        $this->meLanguageid = $meLanguageid;
    }



    /**
     * Returns the fallbackLanguage
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Language $fallbackLanguage
     */
    public function getFallbackLanguage()
    {
        if ($this->fallbackLanguage instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->fallbackLanguage = $this->fallbackLanguage->_loadRealInstance();
        }
        return $this->fallbackLanguage;
    }

    /**
     * Sets the fallbackLanguage
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Language $fallbackLanguage
     * @return void
     */
    public function setFallbackLanguage(\Internetgalerie\IgsCrm\Domain\Model\Language $fallbackLanguage = null)
    {
        $this->fallbackLanguage = $fallbackLanguage;
    }

    public function getFallbackLanguageLocale(array $allowedLanguages = ['de', 'fr'])
    {
        $fallbackLanguage = $this->getFallbackLanguage($allowedLanguages);
        if ($fallbackLanguage instanceof \Internetgalerie\IgsCrm\Domain\Model\Language) {
            return $fallbackLanguage->getLgLocale();
        }
        return '';
    }

    /**
     * Returns the meAnredeId
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Anrede $meAnredeId
     */
    public function getMeAnredeId()
    {
        return $this->meAnredeId;
    }

    public function getSex(): string
    {
        if ($this->meAnredeId == 1) {
            return 'm';
        }
        return $this->meAnredeId == 2 ? 'f' : 'd' ;
    }

    /**
     * Returns the meAnrede
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Anrede $meAnrede
     */
    public function getMeAnrede()
    {
        if (is_object($this->meAnredeId)) {
            return $this->meAnredeId->getAnName();
        } else {
            return null;
        }
    }
    public function getAnredeId()
    {
        if (is_object($this->meAnredeId)) {
            return $this->meAnredeId->getUid();
        } else {
            return null;
        }
    }

    /**
     * Sets the meAnredeId
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Anrede $meAnredeId
     * @return void
     */
    public function setMeAnredeId(\Internetgalerie\IgsCrm\Domain\Model\Anrede $meAnredeId = null)
    {
        $this->meAnredeId = $meAnredeId;
    }

    /**
     * Returns the meKantonId
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Kanton $meKantonId
     */
    public function getMeKantonId()
    {
        if ($this->meKantonId instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->meKantonId->_loadRealInstance();
        }
        return $this->meKantonId;
    }
    public function getStateAbbreviation(): ?string
    {
        if (is_object($this->meKantonId)) {
            return $this->meKantonId->getKaAbkuerzung();
        } else {
            return null;
        }
    }
    /**
     * Returns the meKantonId
     */
    public function getMeKanton(): ?string
    {
        return $this->getStateAbbreviation();
    }

    
    /**
     * Sets the meKantonId
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Kanton $meKantonId
     * @return void
     */
    public function setMeKantonId($meKantonId)
    {
        $this->meKantonId = $meKantonId;
    }


    /**
     * Adds a Phonenumber
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Phonenumber $mePhoneNumberId
     * @return void
     */
    public function addMePhoneNumberId(\Internetgalerie\IgsCrm\Domain\Model\Phonenumber $mePhoneNumberId)
    {
        $this->mePhoneNumberId->attach($mePhoneNumberId);
    }

    /**
     * Removes a Phonenumber
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Phonenumber $mePhoneNumberIdToRemove The Phonenumber to be removed
     * @return void
     */
    public function removeMePhoneNumberId(\Internetgalerie\IgsCrm\Domain\Model\Phonenumber $mePhoneNumberIdToRemove)
    {
        $this->mePhoneNumberId->detach($mePhoneNumberIdToRemove);
    }

    /**
     * Returns the mePhoneNumberId
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Phonenumber> $mePhoneNumberId
     */
    public function getMePhoneNumberId()
    {
        return $this->mePhoneNumberId;
    }


    /**
     * Sets the mePhoneNumberId
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Phonenumber> $mePhoneNumberId
     * @return void
     */
    public function setMePhoneNumberId(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $mePhoneNumberId)
    {
        $this->mePhoneNumberId = $mePhoneNumberId;
    }

    /**
     * Adds a Emailaddress
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Emailaddress $meEmailaddressId
     * @return void
     */
    public function addMeEmailaddressId(\Internetgalerie\IgsCrm\Domain\Model\Emailaddress $meEmailaddressId)
    {
        $this->meEmailaddressId->attach($meEmailaddressId);
    }

    /**
     * Removes a Emailaddress
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Emailaddress $meEmailaddressIdToRemove The Emailaddress to be removed
     * @return void
     */
    public function removeMeEmailaddressId(\Internetgalerie\IgsCrm\Domain\Model\Emailaddress $meEmailaddressIdToRemove)
    {
        $this->meEmailaddressId->detach($meEmailaddressIdToRemove);
    }

    /**
     * Returns the meEmailaddressId
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Emailaddress> $meEmailaddressId
     */
    public function getMeEmailaddressId()
    {
        return $this->meEmailaddressId;
    }

    /**
     * Sets the meEmailaddressId
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Emailaddress> $meEmailaddressId
     * @return void
     */
    public function setMeEmailaddressId(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $meEmailaddressId)
    {
        $this->meEmailaddressId = $meEmailaddressId;
    }

    /**
     * Adds a Messages
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Message $messages
     * @return void
     */
    public function addMessages(\Internetgalerie\IgsCrm\Domain\Model\Message $messages)
    {
        $this->messages->attach($messages);
    }

    /**
     * Removes a Messages
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Message $messagesToRemove The Messages to be removed
     * @return void
     */
    public function removeMessages(\Internetgalerie\IgsCrm\Domain\Model\Message $messagesToRemove)
    {
        $this->messages->detach($messagesToRemove);
    }

    /**
     * Returns the messages
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Message> $messages
     */
    public function getMessages()
    {
        return $this->messages;
    }

    /**
     * Sets the messages
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Message> $messages
     * @return void
     */
    public function setMessages(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $messages)
    {
        $this->messages = $messages;
    }








    /**
     * Adds a CategoryOrganisation
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\CategoryOrganisation $organisationCategory
     * @return void
     */
    public function addOfCategoryOrganisationId(\Internetgalerie\IgsCrm\Domain\Model\CategoryOrganisation $organisationCategory)
    {
        $this->organisationCategory->attach($organisationCategory);
    }

    /**
     * Removes a CategoryOrganisation
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\CategoryOrganisation $organisationCategoryToRemove The CategoryOrganisation to be removed
     * @return void
     */
    public function removeOfCategoryOrganisationId(\Internetgalerie\IgsCrm\Domain\Model\CategoryOrganisation $organisationCategoryToRemove)
    {
        $this->organisationCategory->detach($organisationCategoryToRemove);
    }


    /**
     * Returns first organisationCategory
     *
     */
    public function getFirstCategoryOrganisation()
    {
        return $this->organisationCategory[0] ?? null;
    }


    /**
     * Returns the organisationCategory
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\CategoryOrganisation> $organisationCategory
     */
    public function getOrganisationCategory()
    {
        return $this->organisationCategory;
    }
    public function hasCategoryOrganisation(int $categoryUid)
    {
        foreach ($this->organisationCategory as $cat) {
            if ($cat->getUid() == $categoryUid) {
                return true;
            }
        }
        return false;
    }

    /**
     * Sets the organisationCategory
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\CategoryOrganisation> $organisationCategory
     * @return void
     */
    public function setOrganisationCategory(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $organisationCategory)
    {
        $this->organisationCategory = $organisationCategory;
    }





    /**
     * Adds a Tag
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Tag $meTagId
     * @return void
     */
    public function addMeTagId(\Internetgalerie\IgsCrm\Domain\Model\Tag $meTagId)
    {
        $this->meTagId->attach($meTagId);
    }

    public function addTagIfNotContains(\Internetgalerie\IgsCrm\Domain\Model\Tag $meTagId)
    {
        if (!$this->meTagId->contains($meTagId)) {
            //$this->isModified = true;
            $this->meTagId->attach($meTagId);
        }
    }

    /**
     * Removes a Tag
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Tag $meTagIdToRemove The Tag to be removed
     * @return void
     */
    public function removeMeTagId(\Internetgalerie\IgsCrm\Domain\Model\Tag $meTagIdToRemove)
    {
        $this->meTagId->detach($meTagIdToRemove);
    }

    /**
     * Returns the meTagId
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Tag> $meTagId
     */
    public function getMeTagId()
    {
        return $this->meTagId;
    }

    /**
     * Sets the meTagId
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Tag> $meTagId
     * @return void
     */
    public function setMeTagId(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $meTagId)
    {
        $this->meTagId = $meTagId;
    }










    /**
     * Returns the meAlter
     *
     * @return string $meAlter
     */
    public function getMeAlter()
    {
        if ($this->meDateOfBirth) {
            $year = intval($this->meDateOfBirth->format('Y'));
        } else {
            $year = 0;
        }
        return intval(date('Y')) - $year;
    }
    public function getMeAlterWithYear()
    {
        if ($this->meDateOfBirth) {
            $year = intval($this->meDateOfBirth->format('Y'));
        } else {
            return null;
            /*
            if ($this->meYearOfBirth) {
                $year = $this->meYearOfBirth;
            }
            */
        }
        return $year>1900 ? intval(date('Y')) - $year : '';
    }

    public function getAgeInYear()
    {
        return $this->getMeAlterWithYear();
    }

    /**
     * Returns Telefon by CatId
     *
     * @return string $phone
     */
    public function getMePhoneNumberIdByCatId($phone_cat)
    {
        $personPhone = $this->mePhoneNumberId;
        foreach ($personPhone as $pn) {
            $pcat = $pn->getPnPhonecategoryid();
            if (is_object($pcat) && $pcat->getUid() == $phone_cat) {
                return $pn->getPnPhonenumber();
            }
        }
        return '';
    }


    /**
     * Returns Telefon G
     *
     * @return string $phone
     */
    public function getMePhoneNumberIdGeschaeft()
    {
        return $this->getMePhoneNumberIdByCatId(2);
    }

    /**
     * Returns Telefon P
     *
     * @return string $phone
     */
    public function getMePhoneNumberIdPrivate()
    {
        return $this->getMePhoneNumberIdByCatId(1);
    }
    public function getMePhoneNumberIdPrivat()
    {
        return $this->getMePhoneNumberIdByCatId(1);
    }
    /**
     * Returns Telefon M
     *
     * @return string $phone
     */
    public function getMePhoneNumberIdMobile()
    {
        return $this->getMePhoneNumberIdByCatId(5);
    }
    /**
     * Returns Telefon Fax
     *
     * @return string $phone
     */
    public function getMePhoneNumberIdFax()
    {
        return $this->getMePhoneNumberIdByCatId(4);
    }



    /**
     * Returns E-Mail by CatId
     *
     * @return string $mail
     */
    public function getMeEmailaddressIdByCatId($cat)
    {
        $personEmail = $this->meEmailaddressId;
        foreach ($personEmail as $pn) {
            $pcat = $pn->getEaEmailcategoryid();
            if (is_object($pcat) && $pcat->getUid() == $cat) {
                return $pn->getEaEmailaddress();
            }
        }
        return '';
    }

    /**
     * Returns E-Mail IGS
     *
     * @return string $mail
     */
    public function getMeEmailaddressIdIgs()
    {
        return $this->getMeEmailaddressIdByCatId(4);
    }
    /**
     * Returns E-Mail geosuisse
     *
     * @return string $mail
     */
    public function getMeEmailaddressIdGeosuisse()
    {
        return $this->getMeEmailaddressIdByCatId(5);
    }
    /**
     * Returns E-Mail Privat
     *
     * @return string $mail
     */
    public function getMeEmailaddressIdPrivat()
    {
        return $this->getMeEmailaddressIdByCatId(2);
    }
    /**
     * Returns E-Mail Geschaeft
     *
     * @return string $mail
     */
    public function getMeEmailaddressIdGeschaeft()
    {
        return $this->getMeEmailaddressIdByCatId(3);
    }
    /**
     * Returns E-Mail Schule
     *
     * @return string $mail
     */
    public function getMeEmailaddressIdSchule()
    {
        return $this->getMeEmailaddressIdByCatId(6);
    }

    /**
         * Returns Sort String
         */
    public function getMeSort(): string
    {
        return mb_substr($this->getLastnameFirstnameSpace(), 0, 7) . mb_substr($this->getMeCity(), 0, 4);
    }

    /**
     * Returns Anrede/Geschlecht D,F,I (getLetterAddressAnredeSprache)
     */
    public function getLetterAddressSalutation(): string
    {
        $lang = $this->getLanguageCode();
        $anrede = $this->getMeAnredeId();
        if (is_object($anrede) && !$anrede->getHideInLetterAddress()) {
            return $anrede->getAnrede($lang);
        }
        return '';
    }
    public function getSalutationForLetter(): string
    {
        return $this->getLetterAddressSalutation();
    }
    public function getSalutation(): string
    {
        $lang = $this->getLanguageCode();
        $anrede = $this->getMeAnredeId();
        if (is_object($anrede)) {
            return $anrede->getAnrede($lang);
        }
        return '';
    }
    public function getSalutationFormal(): string
    {
        $lang = $this->getLanguageCode();
        $anrede = $this->getMeAnredeId();
        if (is_object($anrede)) {
            return $this->removeTagName($anrede->getLetterFormal($lang));
        }
        return '';
    }
    public function getSalutationInformal(): string
    {
        $lang = $this->getLanguageCode();
        $anrede = $this->getMeAnredeId();
        if (is_object($anrede)) {
            return $this->removeTagName($anrede->getLetterInformal($lang));
        }
        return '';
    }
    public function getSalutationLetterFormal(): string
    {
        $lang = $this->getLanguageCode();
        $anrede = $this->getMeAnredeId();
        if (is_object($anrede)) {
            return $this->replaceTagName($anrede->getLetterFormal($lang));
        }
        return '';
    }
    public function getSalutationLetterInformal(): string
    {
        $lang = $this->getLanguageCode();
        $anrede = $this->getMeAnredeId();
        if (is_object($anrede)) {
            return $this->replaceTagName($anrede->getLetterInformal($lang));
        }
        return '';
    }

    /**
     * Returns Anrede/Geschlecht D,F,I
     */
    public function getAnredeSprache(): string
    {
        $lang = $this->getLanguageCode();

        $anrede = $this->getMeAnredeId();
        if (is_object($anrede)) {
            return $anrede->getAnrede($lang);
        }
        return '';
    }


    /**
     * Returns Anrede/Geschlecht D+F
     */
    public function getAnredeDF(): string
    {
        $lang = $this->getLanguageCode();
        if ($lang !='F' && $lang!='FR' && $lang!='fr') {
            $lang='D';
        }
        $anrede = $this->getMeAnredeId();
        if (is_object($this->meAnredeId)) {
            return  $anrede->getAnrede($lang);
        }
        return '';
    }
    /**
     * Returns Anrede/Geschlecht D (bzw. Browser Sprache)
     */
    public function getAnrede(): string
    {
        $anrede = $this->getMeAnredeId();
        if (is_object($anrede)) {
            return $anrede->getAnrede($this->getLanguageCode());
        }
        return '';
    }




    /**
     * Returns the meIsBerufsbildner
     *
     * @return boolean $meIsBerufsbildner
     */
    public function getMeIsBerufsbildner()
    {
        return $this->meIsBerufsbildner;
    }

    /**
     * Sets the meIsBerufsbildner
     *
     * @param boolean $meIsBerufsbildner
     * @return void
     */
    public function setMeIsBerufsbildner($meIsBerufsbildner)
    {
        $this->meIsBerufsbildner = $meIsBerufsbildner;
    }

    /**
     * Returns the boolean state of meIsBerufsbildner
     *
     * @return boolean
     */
    public function isMeIsBerufsbildner()
    {
        return $this->meIsBerufsbildner;
    }



    /**
     * Returns the meIsLernende
     *
     * @return boolean $meIsLernende
     */
    public function getMeIsLernende()
    {
        return $this->meIsLernende;
    }

    /**
     * Sets the meIsLernende
     *
     * @param boolean $meIsLernende
     * @return void
     */
    public function setMeIsLernende($meIsLernende)
    {
        $this->meIsLernende = $meIsLernende;
    }

    /**
     * Returns the boolean state of meIsLernende
     *
     * @return boolean
     */
    public function isMeIsLernende()
    {
        return $this->meIsLernende;
    }

    /**
     * Returns the meKlasse
     *
     * @return string $meKlasse
     */
    public function getMeKlasse()
    {
        return $this->meKlasse;
    }

    /**
     * Sets the meKlasse
     *
     * @param string $meKlasse
     * @return void
     */
    public function setMeKlasse($meKlasse)
    {
        $this->meKlasse = $meKlasse;
    }

    /**
     * Returns the meExternIdNamespace
     *
     * @return string $meExternIdNamespace
     */
    public function getMeExternIdNamespace()
    {
        return $this->meExternIdNamespace;
    }

    /**
     * Sets the meExternIdNamespace
     *
     * @param string $meExternIdNamespace
     * @return void
     */
    public function setMeExternIdNamespace($meExternIdNamespace)
    {
        $this->meExternIdNamespace = $meExternIdNamespace;
    }

    /**
     * Returns the meExternId
     *
     * @return string $meExternId
     */
    public function getMeExternId()
    {
        return $this->meExternId;
    }

    /**
     * Sets the meExternId
     *
     * @param string $meExternId
     * @return void
     */
    public function setMeExternId($meExternId)
    {
        $this->meExternId = $meExternId;
    }


    /**
     * Returns the meBmTyp
     *
     * @return string $meBmTyp
     */
    public function getMeBmTyp()
    {
        return $this->meBmTyp;
    }

    /**
     * Sets the meBmTyp
     *
     * @param string $meBmTyp
     * @return void
     */
    public function setMeBmTyp($meBmTyp)
    {
        $this->meBmTyp = $meBmTyp;
    }


    /**
     * Returns the meHeimatort
     *
     * @return string $meHeimatort
     */
    public function getMeHeimatort()
    {
        return $this->meHeimatort;
    }

    /**
     * Sets the meHeimatort
     *
     * @param string $meHeimatort
     * @return void
     */
    public function setMeHeimatort($meHeimatort)
    {
        $this->meHeimatort = $meHeimatort;
    }


    /**
     * Returns the meLbTyp
     *
     * @return string $meLbTyp
     */
    public function getMeLbTyp()
    {
        return $this->meLbTyp;
    }

    /**
     * Sets the meLbTyp
     *
     * @param string $meLbTyp
     * @return void
     */
    public function setMeLbTyp($meLbTyp)
    {
        $this->meLbTyp = $meLbTyp;
    }


    /**
     * Returns the meBranche
     *
     * @return string $meBranche
     */
    public function getMeBranche()
    {
        return $this->meBranche;
    }

    /**
     * Sets the meBranche
     *
     * @param string $meBranche
     * @return void
     */
    public function setMeBranche($meBranche)
    {
        $this->meBranche = $meBranche;
    }




    /**
     * Returns Anrede ohne Name
     */
    public function getBriefanrede(): string
    {
        // evtl. noch Sprache rein

        $anrede = $this->getMeAnredeId();
        if (is_object($anrede)) {
            $anredeText = $anrede->getBriefanrede($this->getLanguageCode());
        } else {
            $anredeText ='';
        }
        $anredeBrief = $this->replaceTagName($anredeText);
        return mb_substr($anredeBrief, 0, 65);
    }
    
    public function getLetterSalutation()
    {
        return $this->getBriefanrede();
    }
    
    /**
         * Returns Anrede
         *
         * @return string $anrede
         */
    public function getBriefanredeDF()
    {
        // evtl. noch Sprache rein
        $lang = $this->getLanguageCode();
        if ($lang !='F' && $lang!='FR' && $lang!='fr') {
            $lang='D';
        }
        $anrede = $this->getMeAnredeId();
        if (is_object($anrede)) {
            $anredeText = $anrede->getBriefanrede($lang);
        } else {
            $anredeText = '';
        }
        $anredeBrief = $this->replaceTagName($anredeText);
        return mb_substr($anredeBrief, 0, 65);
    }

    /**
         * Returns Anrede ohne Name
         *
         * @return string $anrede
         */
    public function getBriefanredeOhneName()
    {
        // evtl. noch Sprache rein

        $anrede = $this->getMeAnredeId();
        if (is_object($anrede)) {
            $anredeText = $anrede->getBriefanrede($this->getLanguageCode());
        } else {
            $anredeText ='';
        }
        $anredeBrief = $this->removeTagName($anredeText);
        return mb_substr($anredeBrief, 0, 65);
    }


    /**
         * Returns Anrede
         *
         * @return string $anrede
         */
    public function getBriefanredeOhneNameDF()
    {
        // evtl. noch Sprache rein
        $lang = $this->getLanguageCode();
        if ($lang !='F' && $lang!='FR'&& $lang!='fr') {
            $lang='D';
        }
        $anrede = $this->getMeAnredeId();
        if (is_object($anrede)) {
            $anredeText = $anrede->getBriefanrede($lang);
        } else {
            $anredeText ='';
        }

        $anredeBrief = $this->removeTagName($anredeText);
        return mb_substr($anredeBrief, 0, 65);
    }


    /**
     * Returns the meLehrbetrieb
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Organisation $meLehrbetrieb
     */
    public function getMeLehrbetrieb()
    {
        return $this->meLehrbetrieb;
    }

    /**
     * Sets the meLehrbetrieb
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Organisation $meLehrbetrieb
     * @return void
     */
    public function setMeLehrbetrieb($meLehrbetrieb)
    {
        $this->meLehrbetrieb = $meLehrbetrieb;
    }



    public function getExtraBetragCurrentYear()
    {
        return 20.00;
    }
    public function getExtraBetragLastYear()
    {
        return 0;
        /*	  $eintritt = $this->getMeGeosuisseStart();
        if( !$eintritt || $eintritt < new \DateTime('2016-01-01') )
          return 20.00;
        else
          return 0;
        */
    }


    public function getEmail()
    {
        return $this->getMeEmail();
    }

    // FIBU: email to use for invoice mail
    public function getInvoiceEmail()
    {
        return $this->getMeEmail();
    }
    // FIBU: combine all invoices in one mail
    public function getOneInvoicePerMail(): ?bool
    {
        return false;
    }
    // FIBU: Extra subject for invoices
    public function getInvoiceMailSubject()
    {
        return null;
    }

    private function similarAddErrors($personsRaw)
    {
        $personsSimilar=[];
        foreach ($personsRaw as $m) {
            $isOk=$m->getEmail()=='' || $this->getEmail()=='' || $m->getEmail()== $this->getEmail();
            $errorAnrede= $m->getMeAnredeId() != $this->getMeAnredeId();
            $errorLanguage= $m->getMeLanguageid() != $this->getMeLanguageid();
            $error = $errorAnrede || $errorLanguage;
            if ($error) {
                $class =  $isOk ? 'merge-error-ok' : 'merge-error-maybe';
                $class.=' error';
            } else {
                $class =  $isOk ? 'merge-ok' : 'merge-maybe';
            }
            $personsSimilar[]=[
                   'person' => $m,
                   'class' => $class,
                   'error' => [
                       'found' => $error,
                       'anrede' => $errorAnrede,
                       'language' => $errorLanguage,
                       ],
                   'checked' => $isOk
                   ];
        }
        return $personsSimilar;
    }



    public function getSimilar()
    {
        $personRepository = GeneralUtility::makeInstance(\Internetgalerie\IgsCrm\Domain\Repository\PersonRepository::class);
        $personsRaw= $personRepository->findSimilar($this);
        return $this->similarAddErrors($personsRaw);
    }
    public function getSimilarWeak()
    {
        $personRepository = GeneralUtility::makeInstance(\Internetgalerie\IgsCrm\Domain\Repository\PersonRepository::class);
        $personsRaw= $personRepository->findSimilarWeak($this);
        return $this->similarAddErrors($personsRaw);
    }


    /**
     * Adds a ContactVerband
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\ContactVerband $meContactVerband
     * @return void
     */
    public function addMeContactVerband(\Internetgalerie\IgsCrm\Domain\Model\ContactVerband $meContactVerband)
    {
        $this->meContactVerband->attach($meContactVerband);
    }

    /**
     * Removes a ContactVerband
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\ContactVerband $meContactVerbandToRemove The ContactVerband to be removed
     * @return void
     */
    public function removeMeContactVerband(\Internetgalerie\IgsCrm\Domain\Model\ContactVerband $meContactVerbandToRemove)
    {
        $this->meContactVerband->detach($meContactVerbandToRemove);
    }

    /**
     * Returns the meContactVerband
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\ContactVerband> $meContactVerband
     */
    public function getMeContactVerband()
    {
        return $this->meContactVerband;
    }
    public function getContactVerbandByVerband(\Internetgalerie\IgsCrm\Domain\Model\Verband $verband)
    {
        return $this->getContactVerbandById($verband->getUid());
    }
    public function getContactVerbandById($verbandId)
    {
        foreach ($this->meContactVerband as $mv) {
            //echo('mv='. $mv->getVerband()->getUid() . '==='. $verbandId);
            if ($mv->getVerband()->getUid()==$verbandId) {
                return $mv;
            }
        }
        return false;
    }
    /*
    public function getMeContactVerband5()
    {
        return $this->getMeContactVerbandById(5);
    }
    */

    /**
     * Sets the meContactVerband
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\ContactVerband> $meContactVerband
     * @return void
     */
    public function setMeContactVerband(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $meContactVerband)
    {
        $this->meContactVerband = $meContactVerband;
    }

    public function __toString()
    {
        return $this->getName();
    }

    /**
     * Get the value of meBriefanrede
     *
     * @return string
     */
    public function getMeBriefanrede()
    {
        return $this->meBriefanrede;
    }

    /**
     * Set the value of meBriefanrede
     *
     * @param string $meBriefanrede
     *
     * @return self
     */
    public function setMeBriefanrede($meBriefanrede)
    {
        $this->meBriefanrede = $meBriefanrede;

        return $this;
    }

    /**
     * Get the value of meIsFamily
     *
     * @return boolean
     */
    public function getMeIsFamily()
    {
        return $this->meIsFamily;
    }

    /**
     * Set the value of meIsFamily
     *
     * @param boolean $meIsFamily
     *
     * @return self
     */
    public function setMeIsFamily($meIsFamily)
    {
        $this->meIsFamily = $meIsFamily;

        return $this;
    }

    /**
     * Get the value of meFamily
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Person
     */
    public function getMeFamily()
    {
        return $this->meFamily;
    }
    public function getFamilyMembers()
    {
        $personRepository = GeneralUtility::makeInstance(\Internetgalerie\IgsCrm\Domain\Repository\PersonRepository::class);
        return $personRepository->findFamilyMembers($this->meFamily, $this->uid);
    }

    /**
     * Set the value of meFamily
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Person $meFamily
     *
     * @return self
     */
    public function setMeFamily(\Internetgalerie\IgsCrm\Domain\Model\Person $meFamily=null)
    {
        $this->meFamily = $meFamily;

        return $this;
    }



    /**
     * Get the value of meInvoiceTo
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Person
     */
    public function getMeInvoiceTo()
    {
        return $this->meInvoiceTo;
    }
    public function getInvoiceToMembers()
    {
        $personRepository = GeneralUtility::makeInstance(\Internetgalerie\IgsCrm\Domain\Repository\PersonRepository::class);
        return $personRepository->findInvoiceToMembers($this->meInvoiceTo, $this->uid);
    }

    /**
     * Set the value of meInvoiceTo
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Person $meInvoiceTo
     *
     * @return self
     */
    public function setMeInvoiceTo(\Internetgalerie\IgsCrm\Domain\Model\Person $meInvoiceTo=null)
    {
        $this->meInvoiceTo = $meInvoiceTo;

        return $this;
    }



    /**
     * Get the value of meIsSammelinvoice
     *
     * @return boolean
     */
    public function getMeIsSammelinvoice()
    {
        return $this->meIsSammelinvoice;
    }

    /**
     * Set the value of meIsSammelinvoice
     *
     * @param boolean $meIsSammelinvoice
     *
     * @return self
     */
    public function setMeIsSammelinvoice($meIsSammelinvoice)
    {
        $this->meIsSammelinvoice = $meIsSammelinvoice;

        return $this;
    }

    /**
	 *
	 * Generates a qr-code and returns the html for the image
	 * @param int $size
	 * @param char $error_level
	 */
	public function getQrCode($size = 3, $error_level = "L") {
        $text = 'http://www.panoramarundweg.ch/q/?p=' . $this->getMeAddressid();
		$cmd = '';
		$cmd .= 'qrencode ' . escapeshellarg ( $text ) . ' -s ' . $size . ' -l ' . $error_level . ' -o ' . getcwd () . "/typo3temp/temp_" . md5 ( $text . $size . $error_level ) . ".png";
		system ( $cmd );
		return '<img src="' . ($_SERVER['HTTPS'] == "on" ? 'https://' : 'http://') . $_SERVER['HTTP_HOST'] . '/typo3temp/temp_' . md5 ( $text . $size . $error_level ) . '.png?url=' . $text . '&s=' . $size . '&l=' . $error_level . '" border="0" />';
	}
    public function getIsOrganisation()
    {
        return false;
    }
    public function getOrganisationName()
    {
        return '';
    }

    public function getContactTag()
    {
        return $this->contactTag;
    }
    public function setContactTag(ContactTag $contactTag)
    {
        $this->contactTag = $contactTag;
    }

    public function getContactContactByOrganisation()
    {
        if ($this->contactContactByOrganisation === null && $this->getUid() > 0) {
            $contactContactRepository = GeneralUtility::makeInstance(ContactContactRepository::class);
            $contactContacts = $contactContactRepository->findByOrganisation($this);
            $this->contactContactByOrganisation = $contactContacts->toArray();
        }
        return $this->contactContactByOrganisation;
    }
    public function getContactContactByContact()
    {
        if ($this->contactContactByContact === null && $this->getUid() > 0) {
            $contactContactRepository = GeneralUtility::makeInstance(ContactContactRepository::class);
            $contactContacts = $contactContactRepository->findByContact($this);
            $this->contactContactByContact = $contactContacts->toArray();
        }
        return $this->contactContactByContact;
    }

    public function getContactContact()
    {
        if ($this->type == 'Organisation') {
            return $this->getContactContactByOrganisation();
        } else {
            return $this->getContactContactByContact();
        }
    }
    public function frontendUserHasAccess(int $frontendUserUid)
    {
        $contactContacts = $this->getContactContact();
        if (!empty($contactContacts)) {
            foreach ($contactContacts as $contactContact) {
                $contact = $contactContact->getContact();
                $frontendUser = $contact->getFrontendUser();
                if ($frontendUser->getUid() === $frontendUserUid) {
                    return true;
                }
            }
        }
        return false;
    }
    /**
     * Returns the aclOwner
     *
     * @return integer $aclOwner
     */
    public function getAclOwner() {
        return $this->aclOwner;
    }

    /**
     * Sets the aclOwner
     *
     * @param integer $aclOwner
     * @return void
     */
    public function setAclOwner($aclOwner) {
        $this->aclOwner = $aclOwner;
    }

    /**
     * Sets the aclReadGroups. Keep in mind that the property is called "aclReadGroups"
     * although it can hold several aclReadGroups.
     *
     * @param ObjectStorage<FrontendUserGroup> $aclReadGroups
     */
    public function setAclReadGroups(ObjectStorage $aclReadGroups)
    {
        $this->aclReadGroups = $aclReadGroups;
    }

    /**
     * Adds a  FrontendUserGroup to aclReadGroups
     *
     * @param FrontendUserGroup $aclReadGroups
     */
    public function addAclReadGroups(FrontendUserGroup $aclReadGroups)
    {
        $this->aclReadGroups->attach($aclReadGroups);
    }

    /**
     * Adds a FrontendUserGroup to aclReadGroups (if not already exists)
     *
     * @param FrontendUserGroup $aclReadGroups
     */
    public function addAclReadGroupsIfNotContains(FrontendUserGroup $aclReadGroups)
    {
        if (!$this->aclReadGroups->contains($aclReadGroups)) {
            $this->aclReadGroups->attach($aclReadGroups);
        }
    }

    /**
     * Removes a aclReadGroups from the frontend user
     *
     * @param FrontendUserGroup $aclReadGroups
     */
    public function removeAclReadGroups(FrontendUserGroup $aclReadGroups)
    {
        $this->aclReadGroups->detach($aclReadGroups);
    }

    /**
     * Returns the aclReadGroups
     *
     * @return ObjectStorage<FrontendUserGroup> An object storage containing the aclReadGroups
     */
    public function getAclReadGroups()
    {
        return $this->aclReadGroups;
    }


    /**
     * Sets the aclWriteGroups. Keep in mind that the property is called "aclWriteGroups"
     * although it can hold several aclWriteGroups.
     *
     * @param ObjectStorage<FrontendUserGroup> $aclWriteGroups
     */
    public function setAclWriteGroups(ObjectStorage $aclWriteGroups)
    {
        $this->aclWriteGroups = $aclWriteGroups;
    }

    /**
     * Adds a aclWriteGroups to the frontend user
     *
     * @param FrontendUserGroup $aclWriteGroups
     */
    public function addAclWriteGroups(FrontendUserGroup $aclWriteGroups)
    {
        $this->aclWriteGroups->attach($aclWriteGroups);
    }

    /**
     * Adds a FrontendUserGroup to aclWriteGroups (if not already exists)
     *
     * @param FrontendUserGroup $aclWriteGroups
     */
    public function addAclWriteGroupsIfNotContains(FrontendUserGroup $aclWriteGroups)
    {
        if (!$this->aclWriteGroups->contains($aclWriteGroups)) {
            $this->aclWriteGroups->attach($aclWriteGroups);
        }
    }

    /**
     * Removes a aclWriteGroups from the frontend user
     *
     * @param FrontendUserGroup $aclWriteGroups
     */
    public function removeAclWriteGroups(FrontendUserGroup $aclWriteGroups)
    {
        $this->aclWriteGroups->detach($aclWriteGroups);
    }

    /**
     * Returns the aclWriteGroups
     *
     * @return ObjectStorage<FrontendUserGroup> An object storage containing the aclWriteGroups
     */
    public function getAclWriteGroups()
    {
        return $this->aclWriteGroups;
    }




    public function aclHasViewPermission(array $groups)
    {
        $aclGroupArray = [];
        foreach ($this->aclReadGroups as $group) {
            $aclGroupArray[] = $group->getUid();
        }
        foreach ($groups as $groupId) {
            if (in_array($groupId, $aclGroupArray)) {
                return true;
            }
        }
        return false;
    }


    /**
     * Get the value of mustReviewed
     *
     * @return boolean
     */
    public function getMustReviewed()
    {
        return $this->mustReviewed;
    }

    /**
     * Set the value of mustReviewed
     *
     * @param boolean $mustReviewed
     *
     * @return self
     */
    public function setMustReviewed($mustReviewed)
    {
        $this->mustReviewed = $mustReviewed;

        return $this;
    }


    /**
     * Get the value of hash
     *
     * @return string
     */
    public function getHash()
    {
        return $this->hash;
    }

    /**
     * Set the value of hash
     *
     * @param string $hash
     *
     * @return self
     */
    public function setHash($hash)
    {
        $this->hash = $hash;

        return $this;
    }

}
