<?php

declare(strict_types=1);

namespace Internetgalerie\IgsCrm\Domain\Model;


/**
 * ContactCertificate
 */
class ContactCertificate extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{
    /**
     * sorting
     *
     * @var integer
     */
    protected $sorting = 0;

    /**
     * certificateYear
     *
     * @var int
     */
    protected $certificateYear = null;

    /**
     * academy
     *
     * @var string
     */
    protected $academy = '';


    /**
     * certificate
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Certificate
     */
    protected $certificate = null;

    /**
     * contact
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Person
     */
    protected $contact = null;
 
    /**
     * Returns the sorting
     *
     * @return integer $sorting
     */
    public function getSorting() {
        return $this->sorting;
    }
 
    /**
     * Sets the sorting
     *
     * @param integer $sorting
     * @return void
     */
    public function setSorting($sorting) {
        $this->sorting = $sorting;
    }
    /**
     * Returns the certificateYear
     *
     * @return int
     */

    /**
     * Returns the academy
     *
     * @return string $academy
     */
    public function getAcademy()
    {
        return $this->academy;
    }
    
    public function getYearAcademy()
    {
        $ret = $this->certificateYear > 0 ? strval($this->certificateYear) : '';
        if ($this->academy) {
            return $ret . ($ret ? ' ' : '') . $this->academy;
        }
        return $ret;
    }
    public function getAcademyYear()
    {
        $ret = $this->certificateYear > 0 ? strval($this->certificateYear) : '';
        if ($this->academy) {
            return $this->academy . ($ret ? ' ' : '') . $ret;
        }
        return $ret;
    }

    /**
     * Sets the academy
     *
     * @param string $academy
     * @return void
     */
    public function setAcademy($academy)
    {
        $this->academy = $academy;
    }

    public function getCertificateYear()
    {
        return $this->certificateYear;
    }

    /**
     * Sets the certificateYear
     *
     * @param int $certificateYear
     * @return void
     */
    public function setCertificateYear(int $certificateYear = null)
    {
        $this->certificateYear = $certificateYear;
    }
    /**
     * Returns the certificate
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Certificate
     */
    public function getCertificate()
    {
        return $this->certificate;
    }

    /**
     * Sets the certificate
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Certificate $certificate
     * @return void
     */
    public function setCertificate(\Internetgalerie\IgsCrm\Domain\Model\Certificate $certificate)
    {
        $this->certificate = $certificate;
    }

    /**
     * Returns the contact
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Person
     */
    public function getContact()
    {
        return $this->contact;
    }

    /**
     * Sets the contact
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Person $contact
     * @return void
     */
    public function setContact(\Internetgalerie\IgsCrm\Domain\Model\Person $contact)
    {
        $this->contact = $contact;
    }
}
