<?php

declare(strict_types=1);

namespace Internetgalerie\IgsCrm\Domain\Model;

/**
 * ContactContact
 */
class ContactContact extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * active
     *
     * @var bool
     */
    protected $active = false;

    /**
     * startDate
     *
     * @var \DateTime
     */
    protected $startDate = null;

    /**
     * endDate
     *
     * @var \DateTime
     */
    protected $endDate = null;

    /**
     * title
     *
     * @var string
     */
    protected $title = '';

    /**
     * acl
     *
     * @var int
     */
    protected $acl = 0;

    /**
     * contact
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Person
     */
    protected $contact = null;

    /**
     * organisation
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Person
     */
    protected $organisation = null;

    /**
     * relationType
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\RelationType
     */
    protected $relationType = null;

    /**
     * relationFunction
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\RelationFunction
     */
    protected $relationFunction = null;

    /**
     * Returns the active
     *
     * @return bool
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * Sets the active
     *
     * @param bool $active
     * @return void
     */
    public function setActive(bool $active)
    {
        $this->active = $active;
    }

    /**
     * Returns the boolean state of active
     *
     * @return bool
     */
    public function isActive()
    {
        return $this->active;
    }

    /**
     * Returns the startDate
     *
     * @return \DateTime
     */
    public function getStartDate()
    {
        return $this->startDate;
    }

    /**
     * Sets the startDate
     *
     * @param \DateTime $startDate
     * @return void
     */
    public function setStartDate(\DateTime $startDate = null)
    {
        $this->startDate = $startDate;
    }

    /**
     * Returns the endDate
     *
     * @return \DateTime
     */
    public function getEndDate()
    {
        return $this->endDate;
    }

    /**
     * Sets the endDate
     *
     * @param \DateTime $endDate
     * @return void
     */
    public function setEndDate(\DateTime $endDate = null)
    {
        $this->endDate = $endDate;
    }

    /**
     * Returns the title
     *
     * @return string
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * Sets the title
     *
     * @param string $title
     * @return void
     */
    public function setTitle(string $title)
    {
        $this->title = $title;
    }

    /**
     * Returns the acl
     *
     * @return int
     */
    public function getAcl()
    {
        return $this->acl;
    }

    /**
     * Sets the acl
     *
     * @param int $acl
     * @return void
     */
    public function setAcl(int $acl)
    {
        $this->acl = $acl;
    }

    /**
     * Returns the contact
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Contact
     */
    public function getContact()
    {
        return $this->contact;
    }

    /**
     * Sets the contact
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Contact $contact
     * @return void
     */
    public function setContact(\Internetgalerie\IgsCrm\Domain\Model\Contact $contact)
    {
        $this->contact = $contact;
    }

    /**
     * Returns the organisation
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Contact
     */
    public function getOrganisation()
    {
        return $this->organisation;
    }

    /**
     * Sets the organisation
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Contact $organisation
     * @return void
     */
    public function setOrganisation(\Internetgalerie\IgsCrm\Domain\Model\Contact $organisation)
    {
        $this->organisation = $organisation;
    }

    /**
     * Returns the relationType
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\RelationType
     */
    public function getRelationType()
    {
        return $this->relationType;
    }

    /**
     * Sets the relationType
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\RelationType $relationType
     * @return void
     */
    public function setRelationType(\Internetgalerie\IgsCrm\Domain\Model\RelationType $relationType = null)
    {
        $this->relationType = $relationType;
    }

    /**
     * Returns the relationFunction
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\RelationFunction
     */
    public function getRelationFunction()
    {
        return $this->relationFunction;
    }

    /**
     * Sets the relationFunction
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\RelationFunction $relationFunction
     * @return void
     */
    public function setRelationFunction(\Internetgalerie\IgsCrm\Domain\Model\RelationFunction $relationFunction = null)
    {
        $this->relationFunction = $relationFunction;
    }
}
