<?php
namespace Internetgalerie\IgsCrm\Domain\Model;

use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Utility\GeneralUtility;

/**
 * ContactVerband
 */
class ContactVerband extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{
    /**
     * active
     *
     * @var bool
     */
    protected $active = false;

    /**
     * startDate
     *
     * @var \DateTime
     */
    protected $startDate = null;

    /**
     * endDate
     *
     * @var \DateTime
     */
    protected $endDate = null;

    /**
     * journal
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Zeitschrift
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $journal = null;

    /**
     * journalEnd
     *
     * @var \DateTime
     */
    protected $journalEnd = null;
    /**
     * journalFreiwillig
     *
     * @var bool
     */
    protected $journalFreiwillig = false;

    /**
     * journalIsFree1
     *
     * @var bool
     */
    protected $journalIsFree1 = false;

    /**
     * journalIsFree2
     *
     * @var bool
     */
    protected $journalIsFree2 = false;

    /**
     * extraTextfield1
     *
     * @var string
     */
    protected $extraTextfield1 = '';

    /**
     * extraTextfield2
     *
     * @var string
     */
    protected $extraTextfield2 = '';

    /**
     * extraTextfield3
     *
     * @var string
     */
    protected $extraTextfield3 = '';

    /**
     * extraTextarea1
     *
     * @var string
     */
    protected $extraTextarea1 = '';

    /**
     * extraTextarea2
     *
     * @var string
     */
    protected $extraTextarea2 = '';

    /**
     * extraTextarea3
     *
     * @var string
     */
    protected $extraTextarea3 = '';

    /**
     * importSource
     *
     * @var string
     */
    protected $importSource = '';
    
    /**
     * externalId
     *
     * @var string
     */
    protected $externalId = '';

    /**
     * address
     *
     * @var string
     */
    protected $address = '';

    /**
     * address2
     *
     * @var string
     */
    protected $address2 = '';

    /**
     * address3
     *
     * @var string
     */
    protected $address3 = '';

    /**
     * pobox
     *
     * @var string
     */
    protected $pobox = '';

    /**
     * zip
     *
     * @var string
     */
    protected $zip = '';

    /**
     * city
     *
     * @var string
     */
    protected $city = '';

    /**
     * email
     *
     * @var string
     */
    protected $email = '';

    /**
     * contact
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Contact
     */
    protected $contact = null;

    /**
     * verband
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Verband
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $verband = null;

    /**
     * mitgliedschaft
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Mitgliedschaft
     */
    protected $mitgliedschaft = null;

    /**
     * company
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Organisation
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $company = null;


    /**
     * organisationId
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Organisation
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $organisationId = null;


    /**
     * invoiceMode
     *
     * @var int
     */
    protected $invoiceMode = 0;

    /**
     * invoiceDeliveryMode
     *
     * @var int
     */
    protected $invoiceDeliveryMode = 0;

    /**
     * invoiceMail
     *
     * @var string
     */
    protected $invoiceMail;

    /**
     * invoiceMailSubject
     *
     * @var string
     */
    protected $invoiceMailSubject;

    /**
     * invoiceReference
     *
     * @var string
     */
    protected $invoiceReference;

    /**
     * invoiceDescription
     *
     * @var string
     */
    protected $invoiceDescription;

    /**
     * invoiceAddress
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Contact
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $invoiceAddress = null;

    /**
     * correspondenceMode
     *
     * @var int
     */
    protected $correspondenceMode = 0;

    /**
     * correspondenceAddress
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Contact
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $correspondenceAddress = null;

    /**
     * correspondenceDeliveryMode
     *
     * @var int
     */
    protected $correspondenceDeliveryMode = 0;

    /**
     * tags
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Tag>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $tags = null;

    /**
     * commissions
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Commission>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $commissions = null;

    /**
     * sektionen
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Sektion>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $sektionen = null;

    /**
     * categories
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Category>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $categories = null;

    /**
     * organisations
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Organisation>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $organisations = null;

    /**
     * __construct
     */
    public function __construct()
    {
        //Do not remove the next line: It would break the functionality
        $this->initStorageObjects();
    }

    /**
     * Initializes all ObjectStorage properties
     * Do not modify this method!
     * It will be rewritten on each save in the extension builder
     * You may modify the constructor of this class instead
     *
     * @return void
     */
    protected function initStorageObjects()
    {
        $this->tags = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->commissions = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->sektionen = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->categories = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
        $this->organisations = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
    }

    /**
     * Returns the active
     *
     * @return bool $active
     */
    public function getActive()
    {
        return $this->active;
    }

    /**
     * Sets the active
     *
     * @param bool $active
     * @return void
     */
    public function setActive($active)
    {
        $this->active = $active;
    }

    /**
     * Returns the boolean state of active
     *
     * @return bool
     */
    public function isActive()
    {
        return $this->active;
    }

    
    /**
     * Returns the startDate
     *
     * @return \DateTime $startDate
     */
    public function getStartDate()
    {
        return $this->startDate;
    }
    public function getIsNew()
    {
        return !$this->getActive() || $this->startDate->format('Y')==date('Y');
    }

    public function getActiveWithDates(): bool
    {
        $now = new \DateTime;
        return $this->active && ($this->startDate === null || $this->startDate <= $now) && ($this->endDate === null || $this->endDate > $now);
    }

    
    /**
     * Sets the startDate
     *
     * @param \DateTime $startDate
     * @return void
     */
    public function setStartDate(\DateTime $startDate=null)
    {
        $this->startDate = $startDate;
    }

    /**
     * Returns the endDate
     *
     * @return \DateTime $endDate
     */
    public function getEndDate()
    {
        return $this->endDate;
    }

    /**
     * Sets the endDate
     *
     * @param \DateTime $endDate
     * @return void
     */
    public function setEndDate(\DateTime $endDate=null)
    {
        $this->endDate = $endDate;
    }

    /**
     * Returns the journal
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Zeitschrift $journal
     */
    public function getJournal()
    {
        if ($this->journal instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->journal->_loadRealInstance();
        }
        return $this->journal;
    }

    /**
     * Sets the journal
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Zeitschrift $journal
     * @return void
     */
    public function setJournal($journal)
    {
        $this->journal = $journal;
    }


    public function getJournalAmount()
    {
        // Existiert Betrag bei dieser Mitgliedschaft
        if ($this->mitgliedschaft && $this->mitgliedschaft->getBetragIsTotal()) {
            return 0;
        }
        $zeitschrift = $this->getJournal();
        if ($zeitschrift) {
            // Wird isFree1 verwendet und ist aktiv
            if ($this->journalIsFree1 && $this->verband->getTitleJournalIsFree1()) {
                return 0;
            }
            // Wird isFree1 verwendet und ist aktiv
            if ($this->journalIsFree2 && $this->verband->getTitleJournalIsFree2()) {
                return 0;
            }
            // journalEnd
            if ($this->isJournalActive()) {
                // @todo kann gelöscht werden journalFreiwillig 
                /*
                if ($this->getJournalFreiwillig() && 0) {
                    return $zeitschrift->getBetrag();
                } else {
                */
                return $zeitschrift->getBetragWithAlter($this->contact->getMeAlterWithYear());
                //}
            }
            return 0;// Inaktives Journal
        }
        return 0;
    }
    public function getVerbandExtraBetragValue()
    {
        // Existiert Betrag bei dieser Mitgliedschaft
        if ($this->mitgliedschaft && $this->mitgliedschaft->getBetragIsTotal()) {
            return 0;
        }
        return $this->getVerband()->getExtraBetragValue();
    }
    /**
     * Amount for membership for this contact
     */
    public function getMembershipAmount($period = null)
    {
        $mitgliedschaft = $this->getMitgliedschaft();
        if (!$mitgliedschaft) {
            return null;
        }
        return $mitgliedschaft->getAmountForContact($this->contact, $period);// @todo only if period is a year
    }


    /**
     * Returns the journalEnd
     *
     * @return \DateTime $journalEnd
     */
    public function getJournalEnd()
    {
        return $this->journalEnd;
    }
    public function isJournalActive()
    {
        return $this->journalEnd===null ||  $this->journalEnd> new \DateTime() ||  $this->journalEnd<=new \DateTime('1901-01-01');
    }

    /**
     * Sets the journalEnd
     *
     * @param \DateTime $journalEnd
     * @return void
     */
    public function setJournalEnd(\DateTime $journalEnd=null)
    {
        $this->journalEnd = $journalEnd;
    }

    /**
     * Returns the journalFreiwillig
     *
     * @return bool $journalFreiwillig
     */
    public function getJournalFreiwillig()
    {
        return $this->journalFreiwillig;
    }

    /**
     * Sets the journalFreiwillig
     *
     * @param bool $journalFreiwillig
     * @return void
     */
    public function setJournalFreiwillig($journalFreiwillig)
    {
        $this->journalFreiwillig = $journalFreiwillig;
    }

    /**
     * Returns the boolean state of journalFreiwillig
     *
     * @return bool
     */
    public function isJournalFreiwillig()
    {
        return $this->journalFreiwillig;
    }

    /**
     * Returns the journalIsFree1
     *
     * @return bool $journalIsFree1
     */
    public function getJournalIsFree1()
    {
        return $this->journalIsFree1;
    }

    /**
     * Sets the journalIsFree1
     *
     * @param bool $journalIsFree1
     * @return void
     */
    public function setJournalIsFree1($journalIsFree1)
    {
        $this->journalIsFree1 = $journalIsFree1;
    }

    /**
     * Returns the boolean state of journalIsFree1
     *
     * @return bool
     */
    public function isJournalIsFree1()
    {
        return $this->journalIsFree1;
    }

    /**
     * Returns the journalIsFree2
     *
     * @return bool $journalIsFree2
     */
    public function getJournalIsFree2()
    {
        return $this->journalIsFree2;
    }

    /**
     * Sets the journalIsFree2
     *
     * @param bool $journalIsFree2
     * @return void
     */
    public function setJournalIsFree2($journalIsFree2)
    {
        $this->journalIsFree2 = $journalIsFree2;
    }

    /**
     * Returns the boolean state of journalIsFree2
     *
     * @return bool
     */
    public function isJournalIsFree2()
    {
        return $this->journalIsFree2;
    }

    /**
     * Returns the extraTextfield1
     *
     * @return string $extraTextfield1
     */
    public function getExtraTextfield1()
    {
        return $this->extraTextfield1;
    }

    /**
     * Sets the extraTextfield1
     *
     * @param string $extraTextfield1
     * @return void
     */
    public function setExtraTextfield1($extraTextfield1)
    {
        $this->extraTextfield1 = $extraTextfield1;
    }

    /**
     * Returns the extraTextfield2
     *
     * @return string $extraTextfield2
     */
    public function getExtraTextfield2()
    {
        return $this->extraTextfield2;
    }

    /**
     * Sets the extraTextfield2
     *
     * @param string $extraTextfield2
     * @return void
     */
    public function setExtraTextfield2($extraTextfield2)
    {
        $this->extraTextfield2 = $extraTextfield2;
    }

    /**
     * Returns the extraTextfield3
     *
     * @return string $extraTextfield3
     */
    public function getExtraTextfield3()
    {
        return $this->extraTextfield3;
    }

    /**
     * Sets the extraTextfield3
     *
     * @param string $extraTextfield3
     * @return void
     */
    public function setExtraTextfield3($extraTextfield3)
    {
        $this->extraTextfield3 = $extraTextfield3;
    }

    /**
     * Returns the extraTextarea1
     *
     * @return string $extraTextarea1
     */
    public function getExtraTextarea1()
    {
        return $this->extraTextarea1;
    }

    /**
     * Sets the extraTextarea1
     *
     * @param string $extraTextarea1
     * @return void
     */
    public function setExtraTextarea1($extraTextarea1)
    {
        $this->extraTextarea1 = $extraTextarea1;
    }

    /**
     * Returns the extraTextarea2
     *
     * @return string $extraTextarea2
     */
    public function getExtraTextarea2()
    {
        return $this->extraTextarea2;
    }

    /**
     * Sets the extraTextarea2
     *
     * @param string $extraTextarea2
     * @return void
     */
    public function setExtraTextarea2($extraTextarea2)
    {
        $this->extraTextarea2 = $extraTextarea2;
    }

    /**
     * Returns the extraTextarea3
     *
     * @return string $extraTextarea3
     */
    public function getExtraTextarea3()
    {
        return $this->extraTextarea3;
    }

    /**
     * Sets the extraTextarea3
     *
     * @param string $extraTextarea3
     * @return void
     */
    public function setExtraTextarea3($extraTextarea3)
    {
        $this->extraTextarea3 = $extraTextarea3;
    }

    /**
     * Returns the importSource
     *
     * @return string $importSource
     */
    public function getImportSource()
    {
        return $this->importSource;
    }

    /**
     * Sets the importSource
     *
     * @param string $importSource
     * @return void
     */
    public function setImportSource($importSource)
    {
        $this->importSource = $importSource;
    }

    
    /**
     * Returns the externalId
     *
     * @return string $externalId
     */
    public function getExternalId()
    {
        return $this->externalId;
    }

    /**
     * Sets the externalId
     *
     * @param string $externalId
     * @return void
     */
    public function setExternalId($externalId)
    {
        $this->externalId = $externalId;
    }


    /**
     * Returns the address
     *
     * @return string $address
     */
    public function getAddress()
    {
        return $this->address;
    }

    /**
     * Sets the address
     *
     * @param string $address
     * @return void
     */
    public function setAddress($address)
    {
        $this->address = $address;
    }

    /**
     * Returns the address2
     *
     * @return string $address2
     */
    public function getAddress2()
    {
        return $this->address2;
    }

    /**
     * Sets the address2
     *
     * @param string $address2
     * @return void
     */
    public function setAddress2($address2)
    {
        $this->address2 = $address2;
    }

    /**
     * Returns the address3
     *
     * @return string $address3
     */
    public function getAddress3()
    {
        return $this->address3;
    }

    /**
     * Sets the address3
     *
     * @param string $address3
     * @return void
     */
    public function setAddress3($address3)
    {
        $this->address3 = $address3;
    }

    /**
     * Returns the pobox
     *
     * @return string $pobox
     */
    public function getPobox()
    {
        return $this->pobox;
    }

    /**
     * Sets the pobox
     *
     * @param string $pobox
     * @return void
     */
    public function setPobox($pobox)
    {
        $this->pobox = $pobox;
    }

    /**
     * Returns the zip
     *
     * @return string $zip
     */
    public function getZip()
    {
        return $this->zip;
    }

    /**
     * Sets the zip
     *
     * @param string $zip
     * @return void
     */
    public function setZip($zip)
    {
        $this->zip = $zip;
    }

    /**
     * Returns the city
     *
     * @return string $city
     */
    public function getCity()
    {
        return $this->city;
    }

    /**
     * Sets the city
     *
     * @param string $city
     * @return void
     */
    public function setCity($city)
    {
        $this->city = $city;
    }

    /**
     * Returns the email
     *
     * @return string $email
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Sets the email
     *
     * @param string $email
     * @return void
     */
    public function setEmail($email)
    {
        $this->email = $email;
    }

    /**
     * Returns the contact
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Contact $contact
     */
    public function getContact()
    {
        return $this->contact;
    }
    public function getPerson()
    {
        return $this->contact;
    }

    /**
     * Sets the contact
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Contact $contact
     * @return void
     */
    public function setContact(\Internetgalerie\IgsCrm\Domain\Model\Contact $contact)
    {
        $this->contact = $contact;
    }

    /**
     * Returns the verband
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Verband $verband
     */
    public function getVerband()
    {
        if ($this->verband instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->verband = $this->verband->_loadRealInstance();
        }
        return $this->verband;
    }
    public function getTenant()
    {
        return $this->getVerband();
    }
    /**
     * Sets the verband
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Verband $verband
     * @return void
     */
    public function setVerband(\Internetgalerie\IgsCrm\Domain\Model\Verband $verband)
    {
        $this->verband = $verband;
    }

    /**
     * Returns the mitgliedschaft
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Mitgliedschaft $mitgliedschaft
     */
    public function getMitgliedschaft()
    {
        return $this->mitgliedschaft;
    }
    public function getMembership()
    {
        return $this->mitgliedschaft;
    }

    /**
     * Sets the mitgliedschaft
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Mitgliedschaft $mitgliedschaft
     * @return void
     */
    public function setMitgliedschaft(\Internetgalerie\IgsCrm\Domain\Model\Mitgliedschaft $mitgliedschaft=null)
    {
        $this->mitgliedschaft = $mitgliedschaft;
    }

    /**
     * Returns the company
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Organisation $company
     */
    public function getCompany()
    {
        return $this->company;
    }

    /**
     * Sets the company
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Organisation $company
     * @return void
     */
    public function setCompany(\Internetgalerie\IgsCrm\Domain\Model\Organisation $company)
    {
        $this->company = $company;
    }
    
    /**
     * Returns the invoiceMode
     *
     * @return int $invoiceMode
     */
    public function getInvoiceMode()
    {
        return $this->invoiceMode;
    }

    /**
     * Sets the invoiceMode
     *
     * @param int $invoiceMode
     * @return void
     */
    public function setInvoiceMode($invoiceMode)
    {
        $this->invoiceMode = $invoiceMode;
    }
    
    public function getInvoiceDeliveryMode(): int
    {
        return $this->invoiceDeliveryMode;
    }

    public function setInvoiceDeliveryMode(int $invoiceDeliveryMode): void
    {
        $this->invoiceDeliveryMode = $invoiceDeliveryMode;
    }
    
    /**
     * Returns the invoiceMail
     *
     * @return string $invoiceMail
     */
    public function getInvoiceMail()
    {
        return $this->invoiceMail;
    }

    /**
     * Sets the invoiceMail
     *
     * @param string $invoiceMail
     * @return void
     */
    public function setInvoiceMail(string $invoiceMail)
    {
        $this->invoiceMail = $invoiceMail;
    }
    
    /**
     * Returns the invoiceMailSubject
     *
     * @return string $invoiceMailSubject
     */
    public function getInvoiceMailSubject()
    {
        return $this->invoiceMailSubject;
    }

    /**
     * Sets the invoiceMailSubject
     *
     * @param string $invoiceMailSubject
     * @return void
     */
    public function setInvoiceMailSubject(string $invoiceMailSubject)
    {
        $this->invoiceMailSubject = $invoiceMailSubject;
    }
    
    /**
     * Returns the invoiceReference
     *
     * @return string $invoiceReference
     */
    public function getInvoiceReference()
    {
        return $this->invoiceReference;
    }

    /**
     * Sets the invoiceReference
     *
     * @param string $invoiceReference
     * @return void
     */
    public function setInvoiceReference(string $invoiceReference)
    {
        $this->invoiceReference = $invoiceReference;
    }

    
    /**
     * Returns the invoiceDescription
     */
    public function getInvoiceDescription(): ?string
    {
        return $this->invoiceDescription;
    }

    /**
     * Sets the invoiceDescription
     */
    public function setInvoiceDescription(string $invoiceDescription): void
    {
        $this->invoiceDescription = $invoiceDescription;
    }

    
    /**
     * Returns the invoiceAddress
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Contact $invoiceAddress
     */
    public function getInvoiceAddress()
    {
        if ($this->invoiceAddress instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->invoiceAddress->_loadRealInstance();
        }
        return $this->invoiceAddress;
    }

    public function getCombinedInvoiceAddress()
    {
        if ($this->invoiceMode == 1) {
            return $this->getOrganisationId();
        } else {
            return $this->getInvoiceAddress() ?? $this->getContact();
        }
    }
    public function getCombinedInvoiceAddressUsed()
    {
        if ($this->invoiceMode == 1) {
            return $this->verband->getTitleOrganisationId() ? : 'Extra Organisation';
        } else {
            if ($this->getInvoiceAddress()) {
                return 'Rechnungsadresse';
            }
            $contact = $this->getContact();
            return $contact ? $contact->getType() : '';

        }
    }

    /**
     * Sets the invoiceAddress
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Contact $invoiceAddress
     * @return void
     */
    public function setInvoiceAddress(\Internetgalerie\IgsCrm\Domain\Model\Contact $invoiceAddress=null)
    {
        $this->invoiceAddress = $invoiceAddress;
    }









    /**
     * Returns the correspondenceMode
     *
     * @return int $correspondenceMode
     */
    public function getCorrespondenceMode()
    {
        return $this->correspondenceMode;
    }

    /**
     * Sets the correspondenceMode
     *
     * @param int $correspondenceMode
     * @return void
     */

    public function setCorrespondenceMode($correspondenceMode)
    {
        $this->correspondenceMode = $correspondenceMode;
    }

    /**
     * Returns the correspondenceAddress
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Contact $correspondenceAddress
     */
    public function getCorrespondenceAddress()
    {
        if ($this->correspondenceAddress instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->correspondenceAddress->_loadRealInstance();
        }
        return $this->correspondenceAddress;
    }
    
    public function getCombinedCorrespondenceAddress()
    {
        if ($this->correspondenceMode == 1) {
            return $this->getOrganisationId();
        } else {
            return $this->getCorrespondenceAddress() ?? $this->getContact();
        }
    }
    public function getCombinedCorrespondenceAddressUsed()
    {
        if ($this->correspondenceMode == 1) {
            return $this->verband->getTitleOrganisationId() ? : 'Extra Organisation';
        } else {
            if ($this->getCorrespondenceAddress()) {
                return 'Korrespondenzadresse';
            }
            $contact = $this->getContact();
            return $contact ? $contact->getType() : '';
        }
    }

    /**
     * Sets the correspondenceAddress
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Contact $correspondenceAddress
     * @return void
     */
    public function setCorrespondenceAddress(\Internetgalerie\IgsCrm\Domain\Model\Contact $correspondenceAddress=null)
    {
        $this->correspondenceAddress = $correspondenceAddress;
    }

    public function getCorrespondenceDeliveryMode(): int
    {
        return $this->correspondenceDeliveryMode;
    }

    public function setCorrespondenceDeliveryMode(int $correspondenceDeliveryMode): void
    {
        $this->correspondenceDeliveryMode = $correspondenceDeliveryMode;
    }

    
    /**
     * Adds a Tag
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Tag $tag
     * @return void
     */
    public function addTag(\Internetgalerie\IgsCrm\Domain\Model\Tag $tag)
    {
        $this->tags->attach($tag);
    }
    public function addTagIfNotContains(\Internetgalerie\IgsCrm\Domain\Model\Tag $tag)
    {
        if (!$this->tags->contains($tag)) {
            $this->tags->attach($tag);
        }
    }

    /**
     * Removes a Tag
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Tag $tagToRemove The Tag to be removed
     * @return void
     */
    public function removeTag(\Internetgalerie\IgsCrm\Domain\Model\Tag $tagToRemove)
    {
        $this->tags->detach($tagToRemove);
    }

    /**
     * Returns the tags
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Tag> $tags
     */
    public function getTags()
    {
        return $this->tags;
    }
    public function getTagIds()
    {
        $tagIds = [];
        foreach ($this->tags as $tag) {
            $tagIds[] = $tag->getUid();
        }
        return $tagIds;
    }
    public function hasTag(\Internetgalerie\IgsCrm\Domain\Model\Tag $tag)
    {
        foreach ($this->tags as $t) {
            if ($t->getUid() == $tag->getUid()) {
                return true;
            }
        }
        return false;
    }
    /**
     * Sets the tags
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Tag> $tags
     * @return void
     */
    public function setTags(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $tags)
    {
        $this->tags = $tags;
    }

    /**
     * Adds a Commission
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Commission $commission
     * @return void
     */
    public function addCommission(\Internetgalerie\IgsCrm\Domain\Model\Commission $commission)
    {
        $this->commissions->attach($commission);
    }

    /**
     * Removes a Commission
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Commission $commissionToRemove The Commission to be removed
     * @return void
     */
    public function removeCommission(\Internetgalerie\IgsCrm\Domain\Model\Commission $commissionToRemove)
    {
        $this->commissions->detach($commissionToRemove);
    }

    /**
     * Returns the commissions
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Commission> $commissions
     */
    public function getCommissions()
    {
        return $this->commissions;
    }

    /**
     * Sets the commissions
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Commission> $commissions
     * @return void
     */
    public function setCommissions(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $commissions)
    {
        $this->commissions = $commissions;
    }

    /**
     * Adds a Sektion
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Sektion $sektionen
     * @return void
     */
    public function addSektionen(\Internetgalerie\IgsCrm\Domain\Model\Sektion $sektionen)
    {
        $this->sektionen->attach($sektionen);
    }

    /**
     * Removes a Sektion
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Sektion $sektionenToRemove The Sektion to be removed
     * @return void
     */
    public function removeSektionen(\Internetgalerie\IgsCrm\Domain\Model\Sektion $sektionenToRemove)
    {
        $this->sektionen->detach($sektionenToRemove);
    }

    /**
     * Returns the sektionen
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Sektion> $sektionen
     */
    public function getSektionen()
    {
        return $this->sektionen;
    }

    /**
     * Sets the sektionen
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Sektion> $sektionen
     * @return void
     */
    public function setSektionen(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $sektionen)
    {
        $this->sektionen = $sektionen;
    }

    /**
     * Adds a Category
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Category $category
     * @return void
     */
    public function addCategory(\Internetgalerie\IgsCrm\Domain\Model\Category $category)
    {
        $this->categories->attach($category);
    }

    /**
     * Removes a Category
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Category $categoryToRemove The Category to be removed
     * @return void
     */
    public function removeCategory(\Internetgalerie\IgsCrm\Domain\Model\Category $categoryToRemove)
    {
        $this->categories->detach($categoryToRemove);
    }

    /**
     * Returns the categories
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Category> $categories
     */
    public function getCategories()
    {
        // remove hidden categories
        $categories = [];
        foreach ($this->categories as $category) {
            if ($category->getUid()>0) {
                $categories[] = $category;
            }
        }
        return $categories;
        //return $this->categories;
    }

    /**
     * Sets the categories
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Category> $categories
     * @return void
     */
    public function setCategories(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $categories)
    {
        $this->categories = $categories;
    }

    /**
     * Returns the organisationId
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Organisation $organisationId
     */
    public function getOrganisationId()
    {        
        if ($this->organisationId instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->organisationId->_loadRealInstance();
        }
        return $this->organisationId;
    }

    /**
     * Sets the organisationId
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Organisation $organisationId
     * @return void
     */
    public function setOrganisationId(\Internetgalerie\IgsCrm\Domain\Model\Organisation $organisationId=null)
    {
        $this->organisationId = $organisationId;
    }

    /**
     * Adds a Organisation
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Organisation $organisation
     * @return void
     */
    public function addOrganisation(\Internetgalerie\IgsCrm\Domain\Model\Organisation $organisation)
    {
        $this->organisations->attach($organisation);
    }
 
    /**
     * Removes a Organisation
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Organisation $organisationToRemove The Organisation to be removed
     * @return void
     */
    public function removeOrganisation(\Internetgalerie\IgsCrm\Domain\Model\Organisation $organisationToRemove)
    {
        $this->organisations->detach($organisationToRemove);
    }
 
    /**
     * Returns the organisations
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Organisation> $organisations
     */
    public function getOrganisations()
    {
        return $this->organisations;
    }
 
    /**
     * Sets the organisations
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Organisation> $organisations
     * @return void
     */
    public function setOrganisations(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $organisations)
    {
        $this->organisations = $organisations;
    }

    

    public function getTagsVerband()
    {
        $tagverbandRepository = GeneralUtility::makeInstance(\Internetgalerie\IgsCrm\Domain\Repository\TagverbandRepository::class);
        return $tagverbandRepository->findByVerband($this->getVerband());
    }

    public function getTagsUids()
    {
        $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('tx_igscrm_contactverband_tag_mm');
        $result = $queryBuilder
                 ->select('uid_foreign')
                 ->from('tx_igscrm_contactverband_tag_mm')
                 ->where($queryBuilder->expr()->eq('uid_local', $queryBuilder->createNamedParameter($this->getUid(), \PDO::PARAM_INT)))
                 ->executeQuery();
        $uids=[];
        while ($row=$result->fetchAssociative()) {
            $uids[$row['uid_foreign']]= $row['uid_foreign'];
        }
        return  $uids;
    }
}
