<?php
namespace Internetgalerie\IgsCrm\Domain\Model;

use TYPO3\CMS\Extbase\Persistence\ObjectStorage;
use Internetgalerie\IgsCrm\Domain\Model\FrontendUser;
use Internetgalerie\IgsCrm\Domain\Model\FrontendUserGroup;


interface EntityWithAcl
{
    /**
     * Returns the aclOwner
     *
     * @return integer $aclOwner
     */
    public function getAclOwner();

    /**
     * Returns the aclWriteGroups 
     *
     * @return ObjectStorage<FrontendUserGroup> An object storage containing the aclWriteGroups
     */
    public function getAclWriteGroups();


    /**
     * Returns the aclReadGroups 
     *
     * @return ObjectStorage<FrontendUserGroup> An object storage containing the aclReadGroups
     */
    public function getAclReadGroups();

    
    /**
     * Adds a FrontendUserGroup to aclReadGroups (if not already exists)
     *
     * @param FrontendUserGroup $aclReadGroups
     */
    public function addAclReadGroupsIfNotContains(FrontendUserGroup $aclReadGroups);

    /**
     * Adds a FrontendUserGroup to aclWriteGroups (if not already exists)
     *
     * @param FrontendUserGroup $aclWriteGroups
     */
    public function addAclWriteGroupsIfNotContains(FrontendUserGroup $aclReadGroups);
    

}