<?php
namespace Internetgalerie\IgsCrm\Domain\Model;

/**
 * Export
 */
class Export extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{
    /**
     * name
     *
     * @var string
     */
    protected $name = '';

    /**
     * className
     *
     * @var string
     */
    protected $className = '';

    /**
     * functionName
     *
     * @var string
     */
    protected $functionName = '';

    /**
     * filename
     *
     * @var string
     */
    protected $filename = '';

    /**
     * fields
     *
     * @var string
     */
    protected $fields = '';

    /**
     * config
     *
     * @var string
     */
    protected $config = '';

    /**
     * Returns the name
     *
     * @return string $name
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Sets the name
     *
     * @param string $name
     * @return void
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * Returns the className
     *
     * @return string $className
     */
    public function getClassName()
    {
        return $this->className;
    }

    /**
     * Sets the className
     *
     * @param string $className
     * @return void
     */
    public function setClassName($className)
    {
        $this->className = $className;
    }

    /**
     * Returns the functionName
     *
     * @return string $functionName
     */
    public function getFunctionName()
    {
        return $this->functionName;
    }

    /**
     * Sets the functionName
     *
     * @param string $functionName
     * @return void
     */
    public function setFunctionName($functionName)
    {
        $this->functionName = $functionName;
    }

    /**
     * Returns the filename
     *
     * @return string $filename
     */
    public function getFilename()
    {
        return $this->filename;
    }

    /**
     * Sets the filename
     *
     * @param string $filename
     * @return void
     */
    public function setFilename($filename)
    {
        $this->filename = $filename;
    }

    /**
     * Returns the fields
     *
     * @return string $fields
     */
    public function getFields()
    {
        return $this->fields;
    }
    public function getFieldsArray()
    {
        return parse_ini_string($this->fields);
    }

    /**
     * Sets the fields
     *
     * @param string $fields
     * @return void
     */
    public function setFields($fields)
    {
        $this->fields = $fields;
    }

    /**
     * Returns the config
     *
     * @return string $config
     */
    public function getConfig()
    {
        return $this->config;
    }
    public function getConfigArray()
    {
        $defaultConfig= [
               'jahr' => 0,
               'showEmail' => 1,
               'showAnrede' => 1,
               'showInvoice' => 1,
               'limitLength' => 0 // keine Limitierung
               ];

        return array_merge($defaultConfig, parse_ini_string($this->config));
    }

    /**
     * Sets the config
     *
     * @param string $config
     * @return void
     */
    public function setConfig($config)
    {
        $this->config = $config;
    }
}
