<?php
namespace Internetgalerie\IgsCrm\Domain\Model;

/**
 * Kurse
 */
class Kurse extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * kuName
     *
     * @var string
     */
    protected $kuName = '';

    /**
     * kuNameFr
     *
     * @var string
     */
    protected $kuNameFr = '';

    /**
     * kuFussnote
     *
     * @var boolean
     */
    protected $kuFussnote = false;

    /**
     * kuKursmodule
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Kursmodule>
     * @TYPO3\CMS\Extbase\Annotation\ORM\Cascade("remove")
     */
    protected $kuKursmodule = null;

    /**
     * kuArt
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Kursart
     */
    protected $kuArt = null;

    /**
     * __construct
     */
    public function __construct()
    {
        //Do not remove the next line: It would break the functionality
        $this->initStorageObjects();
    }

    /**
     * Initializes all ObjectStorage properties
     * Do not modify this method!
     * It will be rewritten on each save in the extension builder
     * You may modify the constructor of this class instead
     *
     * @return void
     */
    protected function initStorageObjects()
    {
        $this->kuKursmodule = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
    }

    /**
     * Returns the kuName
     *
     * @return string $kuName
     */
    public function getKuName()
    {
        return $this->kuName;
    }

    /**
     * Sets the kuName
     *
     * @param string $kuName
     * @return void
     */
    public function setKuName($kuName)
    {
        $this->kuName = $kuName;
    }

    /**
     * Returns the kuNameFr
     *
     * @return string $kuNameFr
     */
    public function getKuNameFr()
    {
        return $this->kuNameFr;
    }

    /**
     * Sets the kuNameFr
     *
     * @param string $kuNameFr
     * @return void
     */
    public function setKuNameFr($kuNameFr)
    {
        $this->kuNameFr = $kuNameFr;
    }

    /**
     * Returns the kuFussnote
     *
     * @return boolean $kuFussnote
     */
    public function getKuFussnote()
    {
        return $this->kuFussnote;
    }

    /**
     * Sets the kuFussnote
     *
     * @param boolean $kuFussnote
     * @return void
     */
    public function setKuFussnote($kuFussnote)
    {
        $this->kuFussnote = $kuFussnote;
    }

    /**
     * Returns the boolean state of kuFussnote
     *
     * @return boolean
     */
    public function isKuFussnote()
    {
        return $this->kuFussnote;
    }

    /**
     * Adds a Kursmodule
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Kursmodule $kuKursmodule
     * @return void
     */
    public function addKuKursmodule(\Internetgalerie\IgsCrm\Domain\Model\Kursmodule $kuKursmodule)
    {
        $this->kuKursmodule->attach($kuKursmodule);
    }

    /**
     * Removes a Kursmodule
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Kursmodule $kuKursmoduleToRemove The Kursmodule to be removed
     * @return void
     */
    public function removeKuKursmodule(\Internetgalerie\IgsCrm\Domain\Model\Kursmodule $kuKursmoduleToRemove)
    {
        $this->kuKursmodule->detach($kuKursmoduleToRemove);
    }

    /**
     * Returns the kuKursmodule
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Kursmodule> $kuKursmodule
     */
    public function getKuKursmodule()
    {
        return $this->kuKursmodule;
    }

    /**
     * Sets the kuKursmodule
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Kursmodule> $kuKursmodule
     * @return void
     */
    public function setKuKursmodule(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $kuKursmodule)
    {
        $this->kuKursmodule = $kuKursmodule;
    }

    /**
     * Returns the kuArt
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Kursart $kuArt
     */
    public function getKuArt()
    {
        return $this->kuArt;
    }

    /**
     * Sets the kuArt
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Kursart $kuArt
     * @return void
     */
    public function setKuArt(\Internetgalerie\IgsCrm\Domain\Model\Kursart $kuArt)
    {
        $this->kuArt = $kuArt;
    }

    /**
     * Returns the Anzahl Teilnehmer
     *
     * @return integer Anzahl Teilnehmer
     */
    public function getAnzahlTeilnehmer()
    {
        $repository = GeneralUtility::makeInstance(\Internetgalerie\IgsCrm\Domain\Repository\KursteilnehmerRepository::class);
        return $repository->countByKtKurse($this->getUid());
    }
}
