<?php
namespace Internetgalerie\IgsCrm\Domain\Model;

/**
 * Kursteilnehmer
 */
class Kursteilnehmer extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * ktStartdatum
     *
     * @var \DateTime
     */
    protected $ktStartdatum = null;

    /**
     * ktEnddatum
     *
     * @var \DateTime
     */
    protected $ktEnddatum = null;

    /**
     * ktDauer
     *
     * @var string
     */
    protected $ktDauer = '';

    /**
     * ktPerson
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Person
     */
    protected $ktPerson = null;

    /**
     * ktKurse
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Kurse
     */
    protected $ktKurse = null;

    /**
     * ktKursmodule
     *
     * @var \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Kursmodule>
     */
    protected $ktKursmodule = null;

    /**
     * __construct
     */
    public function __construct()
    {
        //Do not remove the next line: It would break the functionality
        $this->initStorageObjects();
    }

    /**
     * Initializes all ObjectStorage properties
     * Do not modify this method!
     * It will be rewritten on each save in the extension builder
     * You may modify the constructor of this class instead
     *
     * @return void
     */
    protected function initStorageObjects()
    {
        $this->ktKursmodule = new \TYPO3\CMS\Extbase\Persistence\ObjectStorage();
    }

    /**
     * Returns the ktStartdatum
     *
     * @return \DateTime $ktStartdatum
     */
    public function getKtStartdatum()
    {
        return $this->ktStartdatum;
    }

    /**
     * Sets the ktStartdatum
     *
     * @param \DateTime $ktStartdatum
     * @return void
     */
    public function setKtStartdatum($ktStartdatum)
    {
        $this->ktStartdatum = $ktStartdatum;
    }

    /**
     * Returns the ktEnddatum
     *
     * @return \DateTime $ktEnddatum
     */
    public function getKtEnddatum()
    {
        return $this->ktEnddatum;
    }

    /**
     * Sets the ktEnddatum
     *
     * @param \DateTime $ktEnddatum
     * @return void
     */
    public function setKtEnddatum($ktEnddatum)
    {
        $this->ktEnddatum = $ktEnddatum;
    }

    /**
     * Returns the ktDauer
     *
     * @return string $ktDauer
     */
    public function getKtDauer()
    {
        return $this->ktDauer;
    }

    /**
     * Sets the ktDauer
     *
     * @param string $ktDauer
     * @return void
     */
    public function setKtDauer($ktDauer)
    {
        $this->ktDauer = $ktDauer;
    }

    /**
     * Returns the ktPerson
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Person $ktPerson
     */
    public function getKtPerson()
    {
        return $this->ktPerson;
    }

    /**
     * Sets the ktPerson
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Person $ktPerson
     * @return void
     */
    public function setKtPerson(\Internetgalerie\IgsCrm\Domain\Model\Person $ktPerson)
    {
        $this->ktPerson = $ktPerson;
    }

    /**
     * Returns the ktKurse
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Kurse $ktKurse
     */
    public function getKtKurse()
    {
        return $this->ktKurse;
    }

    /**
     * Sets the ktKurse
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Kurse $ktKurse
     * @return void
     */
    public function setKtKurse(\Internetgalerie\IgsCrm\Domain\Model\Kurse $ktKurse)
    {
        $this->ktKurse = $ktKurse;
    }

    /**
     * Adds a Kursmodule
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Kursmodule $ktKursmodule
     * @return void
     */
    public function addKtKursmodule(\Internetgalerie\IgsCrm\Domain\Model\Kursmodule $ktKursmodule)
    {
        $this->ktKursmodule->attach($ktKursmodule);
    }

    /**
     * Removes a Kursmodule
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Kursmodule $ktKursmoduleToRemove The Kursmodule to be removed
     * @return void
     */
    public function removeKtKursmodule(\Internetgalerie\IgsCrm\Domain\Model\Kursmodule $ktKursmoduleToRemove)
    {
        $this->ktKursmodule->detach($ktKursmoduleToRemove);
    }

    /**
     * Returns the ktKursmodule
     *
     * @return \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Kursmodule> $ktKursmodule
     */
    public function getKtKursmodule()
    {
        return $this->ktKursmodule;
    }

    /**
     * Sets the ktKursmodule
     *
     * @param \TYPO3\CMS\Extbase\Persistence\ObjectStorage<\Internetgalerie\IgsCrm\Domain\Model\Kursmodule> $ktKursmodule
     * @return void
     */
    public function setKtKursmodule(\TYPO3\CMS\Extbase\Persistence\ObjectStorage $ktKursmodule)
    {
        $this->ktKursmodule = $ktKursmodule;
    }
}
