<?php
namespace Internetgalerie\IgsCrm\Domain\Model;

use Internetgalerie\IgsCrm\Domain\Repository\TagFieldRepository;
use TYPO3\CMS\Core\Utility\GeneralUtility;

/**
 * Tag
 */
class Tag extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * name
     *
     * @var string
     */
    protected $name = '';

    /**
     * hasRoles
     *
     * @var bool
     */
    protected $hasRoles = '';
    

    /**
     * usergroup
     *
     * @var string
     */
    protected $usergroup = '';

    /**
     * verband
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Verband
     */
    protected $verband = null;
    
    /**
     * tagverband
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Tagverband
     */
    protected $tagverband = null;

    /**
     * Returns the name
     *
     * @return string $name
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Sets the name
     *
     * @param string $name
     * @return void
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * Returns the hasRoles
     *
     * @return bool $hasRoles
     */
    public function getHasRoles()
    {
        return $this->hasRoles;
    }

    /**
     * Sets the hasRoles
     *
     * @param bool $hasRoles
     * @return void
     */
    public function setHasRoles($hasRoles)
    {
        $this->hasRoles = $hasRoles;
    }
    public function getTextfields()
    {
        if ($this->tagFields === null) {
            $tagFieldRepository = GeneralUtility::makeInstance(TagFieldRepository::class);
            $this->tagFields = $tagFieldRepository->findByTag($this);
        }
        return $this->tagFields;
    }

    /**
     * Returns the usergroup
     *
     * @return string $usergroup
     */
    public function getUsergroup()
    {
        return $this->usergroup;
    }

    /**
     * Sets the usergroup
     *
     * @param string $usergroup
     * @return void
     */
    public function setUsergroup($usergroup)
    {
        $this->usergroup = $usergroup;
    }

    /**
     * Returns the verband
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Verband $verband
     */
    public function getVerband()
    {
        return $this->verband;
    }

    /**
     * Sets the verband
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Verband $verband
     * @return void
     */
    public function setVerband(\Internetgalerie\IgsCrm\Domain\Model\Verband $verband)
    {
        $this->verband = $verband;
    }

    /**
     * Returns the tagverband
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Tagverband $tagverband
     */
    public function getTagverband()
    {
        return $this->tagverband;
    }

    /**
     * Sets the tagverband
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Tagverband $tagverband
     * @return void
     */
    public function setTagverband(\Internetgalerie\IgsCrm\Domain\Model\Tagverband $tagverband)
    {
        $this->tagverband = $tagverband;
    }
    
    public function __toString()
    {
        return $this->getName();
    }
}
