<?php
namespace Internetgalerie\IgsCrm\Domain\Model;

use TYPO3\CMS\Core\Utility\GeneralUtility;


/**
 * TagField
 */
class TagField extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * title
     *
     * @var string
     */
    protected $title = '';

    /**
     * sorting
     *
     * @var integer
     */
    protected $sorting = 0;

    /**
     * fieldNumber
     *
     * @var integer
     */
    protected $fieldNumber = 0;

    /**
     * isTranslated
     *
     * @var boolean
     */
    protected $isTranslated = false;

    /**
     * tag
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Tag
     */
    protected $tag = null;


    /**
     * Returns the title
     *
     * @return string $title
     */
    public function getTitle()
    {
        return $this->title;
    }

    /**
     * Sets the title
     *
     * @param string $title
     * @return void
     */
    public function setTitle($title)
    {
        $this->title = $title;
    }


    /**
     * Returns the fieldNumber
     *
     * @return integer $fieldNumber
     */
    public function getFieldNumber() {
        return $this->fieldNumber;
    }
 
    /**
     * Sets the fieldNumber
     *
     * @param integer $fieldNumber
     * @return void
     */
    public function setFieldNumber($fieldNumber) {
        $this->fieldNumber = $fieldNumber;
    }
    
    /**
     * Returns the sorting
     *
     * @return integer $sorting
     */
    public function getSorting() {
        return $this->sorting;
    }
 
    /**
     * Sets the sorting
     *
     * @param integer $sorting
     * @return void
     */
    public function setSorting($sorting) {
        $this->sorting = $sorting;
    }


    /**
     * Get the value of isTranslated
     *
     * @return boolean
     */
    public function getIsTranslated()
    {
        return $this->isTranslated;
    }

    /**
     * Set the value of isTranslated
     *
     * @param boolean $isTranslated
     *
     * @return self
     */
    public function setIsTranslated($isTranslated)
    {
        $this->isTranslated = $isTranslated;
    }

    
    /**
     * Returns the tag
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Tag $tag
     */
    public function getTag()
    {
        return $this->tag;
    }

    /**
     * Sets the tag
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Tag $tag
     * @return void
     */
    public function setTag(\Internetgalerie\IgsCrm\Domain\Model\Tag $tag)
    {
        $this->tag = $tag;
    }

    public function __toString()
    {
        $str = $this->getTitle();
        return $str;
    }

}
