<?php
namespace Internetgalerie\IgsCrm\Domain\Model;

use TYPO3\CMS\Core\Utility\GeneralUtility;


/**
 * Tagverband
 */
class Tagverband extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{

    /**
     * name
     *
     * @var string
     */
    protected $name = '';

    /**
     * verband
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Verband
     */
    protected $verband = null;

    /**
     * tagRepository
     *
     * @var \Internetgalerie\IgsCrm\Domain\Repository\TagRepository
     */
    protected $tagRepository = null;

    /**
     * Returns the name
     *
     * @return string $name
     */
    public function getName()
    {
        return $this->name;
    }

    /**
     * Sets the name
     *
     * @param string $name
     * @return void
     */
    public function setName($name)
    {
        $this->name = $name;
    }

    /**
     * Returns the verband
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Verband $verband
     */
    public function getVerband()
    {
        return $this->verband;
    }

    /**
     * Sets the verband
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Verband $verband
     * @return void
     */
    public function setVerband(\Internetgalerie\IgsCrm\Domain\Model\Verband $verband)
    {
        $this->verband = $verband;
    }

    public function __toString()
    {
        $str = $this->getName();
        return $str;
    }

    public function getTags()
    {
        if ($this->tagRepository===null) {
            $this->tagRepository = GeneralUtility::makeInstance(\Internetgalerie\IgsCrm\Domain\Repository\TagRepository::class);
        }
        return $this->tagRepository->findByTagverband($this->getUid());
    }


    public function getTagsWithNone()
    {
        if ($this->tagRepository===null) {
            $this->tagRepository = GeneralUtility::makeInstance(\Internetgalerie\IgsCrm\Domain\Repository\TagRepository::class);
        }
        $tags=[];
        foreach ($this->tagRepository->findByTagverband($this->getUid()) as $tag) {
            $tags[$tag->getUid()]=$tag->getName();
        }
        $tags[-$this->getUid()]='-- Ohne Kategorie ---';
        return $tags;
    }
}
