<?php
namespace Internetgalerie\IgsCrm\Domain\Model;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Persistence\QueryResultInterface;

/**
 * Translate
 */
class Translate extends \TYPO3\CMS\Extbase\DomainObject\AbstractEntity
{
    /**
     * verband
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Verband
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $verband = null;
    
    /**
     * Kommunikationssprache
     *
     * @var \Internetgalerie\IgsCrm\Domain\Model\Language
     * @TYPO3\CMS\Extbase\Annotation\ORM\Lazy
     */
    public $crmLanguage = null;

    /**
     * textKey
     *
     * @var string
     */
    protected $textKey = '';

    /**
     * textValue
     *
     * @var string
     */
    protected $textValue = '';

    
    /**
     * Returns the verband
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Verband $verband
     */
    public function getVerband()
    {
        if ($this->verband instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->verband = $this->verband->_loadRealInstance();
        }
        return $this->verband;
    }

    /**
     * Sets the verband
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Verband $verband
     * @return void
     */
    public function setVerband(\Internetgalerie\IgsCrm\Domain\Model\Verband $verband)
    {
        $this->verband = $verband;
    }

    /**
     * Returns the crmLanguage
     *
     * @return \Internetgalerie\IgsCrm\Domain\Model\Language $crmLanguage
     */
    public function getCrmLanguage()
    {
        if ($this->crmLanguage instanceof \TYPO3\CMS\Extbase\Persistence\Generic\LazyLoadingProxy) {
            $this->crmLanguage = $this->crmLanguage->_loadRealInstance();
        }
        return $this->crmLanguage;
    }

    /**
     * Sets the crmLanguage
     *
     * @param \Internetgalerie\IgsCrm\Domain\Model\Language $crmLanguage
     * @return void
     */
    public function setCrmLanguage(\Internetgalerie\IgsCrm\Domain\Model\Language $crmLanguage = null)
    {
        $this->crmLanguage = $crmLanguage;
    }
    
    /**
     * Returns the textKey
     *
     * @return string $textKey
     */
    public function getTextKey()
    {
        return $this->textKey;
    }

    /**
     * Sets the textKey
     *
     * @param string $textKey
     * @return void
     */
    public function setTextKey($textKey)
    {
        $this->textKey = $textKey;
    }

    
    /**
     * Returns the textValue
     *
     * @return string $textValue
     */
    public function getTextValue()
    {
        return $this->textValue;
    }

    /**
     * Sets the textValue
     *
     * @param string $textValue
     * @return void
     */
    public function setTextValue($textValue)
    {
        $this->textValue = $textValue;
    }

    
}