<?php

declare(strict_types=1);

namespace Internetgalerie\IgsCrm\Domain\Repository;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Persistence\Generic\Typo3QuerySettings;
use TYPO3\CMS\Extbase\Persistence\Repository;

/**
 * A Frontend User repository
 */
class FrontendUserRepository extends Repository
{
    protected function initDefaultQuerySettings()
    {
        if ($this->defaultQuerySettings === null) {        
            $this->defaultQuerySettings = GeneralUtility::makeInstance(Typo3QuerySettings::class);
        }
    }

    public function setStoragePageId(int $storagePageId)
    {
        $this->initDefaultQuerySettings();
        $this->defaultQuerySettings->setStoragePageIds([$storagePageId]);
    }
    public function setRespectStoragePage(bool $respectStoragePage)
    {
        $this->initDefaultQuerySettings();
        $this->defaultQuerySettings->setRespectStoragePage($respectStoragePage);
    }

}
