<?php
namespace Internetgalerie\IgsCrm\Domain\Repository;

use Internetgalerie\IgsCrm\Domain\Model\Person;
use Internetgalerie\IgsCrm\Utility\SecurityUtility;
use TYPO3\CMS\Core\Database\ConnectionPool;
use TYPO3\CMS\Core\Utility\ClassNamingUtility;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Persistence\Generic\Mapper\DataMapper;
use TYPO3\CMS\Extbase\Persistence\QueryInterface;
use TYPO3\CMS\Extbase\Persistence\Generic\QuerySettingsInterface;
use TYPO3\CMS\Extbase\Persistence\Generic\Storage\Typo3DbQueryParser;
use TYPO3\CMS\Extbase\Utility\DebuggerUtility;

/**
 * The repository for Persons
 */
class PersonRepository extends ContactRepository
{
    protected $tablename = 'tx_igscrm_domain_model_contact';
    protected $type = 'Person';
    protected $objectType = Person::class;

    protected $defaultOrderings = [
        'extraSorting' => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING,
        'meLastname' => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING,
        'meFirstname' => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING,
        'meCompanyname' => \TYPO3\CMS\Extbase\Persistence\QueryInterface::ORDER_ASCENDING,
    ];

    /**
     * is needed for update at least in TYPO3 11 for organisation(19.5.2023)
     */
    public function initializeObject()
    {
        $this->type = 'Person';
        $this->objectType = Person::class;

    }


    public function findEmployeeByTenant($tenant = null)
    {
        $queryBuilder = $this->createContactQueryBuilder();
        $queryBuilder->addUserRestriction();
        $queryBuilder->select($this->tablename . '.*');
        $queryBuilder->from($this->tablename);
        $queryBuilder->andWhere('(frontend_user IS NOT NULL AND frontend_user<>0)');
        $rows = $queryBuilder->executeQuery()->fetchAllAssociative();
        return $this->dataMapper->map(Person::class, $rows);

    }
}
