<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Acl;

use Internetgalerie\IgsCrm\Domain\Model\EntityWithAcl;
use Internetgalerie\IgsCrm\Utility\SecurityUtility;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractConditionViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class CanWriteViewHelper extends AbstractConditionViewHelper
{
    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        $this->registerArgument('object', EntityWithAcl::class, 'EntityWithAcl like Person', true);
        $this->registerArgument('role', 'string', 'additionalGroups', false, []);
    }
   /**
     * This method decides if the condition is TRUE or FALSE. It can be overriden in extending viewhelpers
     * to adjust functionality.
     *
     * @param array $arguments ViewHelper arguments to evaluate the condition for this ViewHelper, allows for
     *                         flexiblity in overriding this method.
     * @return bool
     */
    protected static function evaluateCondition($arguments = null)
    {
        $object = $arguments['object'];
        if (!$object instanceof EntityWithAcl) {
            return false;
        }

        $roles = GeneralUtility::trimExplode(',', $arguments['role'], true);

        $securityUtility = GeneralUtility::makeInstance(SecurityUtility::class);

        return $securityUtility->aclCanWrite($object, $roles);
    }

}
