<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Acl;

use Internetgalerie\IgsCrm\Domain\Model\EntityWithAcl;
use Internetgalerie\IgsCrm\Utility\SecurityUtility;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractConditionViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Extbase\Persistence\ObjectStorage;

class ContainsViewHelper extends AbstractConditionViewHelper
{
    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        $this->registerArgument('needle', ObjectStorage::class, 'aclGroups needle', true);
        $this->registerArgument('haystack', ObjectStorage::class, 'aclGroups haystack', true);
    }
   /**
     * This method decides if the condition is TRUE or FALSE. It can be overriden in extending viewhelpers
     * to adjust functionality.
     *
     * @param array $arguments ViewHelper arguments to evaluate the condition for this ViewHelper, allows for
     *                         flexiblity in overriding this method.
     * @return bool
     */
    protected static function evaluateCondition($arguments = null)
    {
        $needle = $arguments['needle'];
        $haystack = $arguments['haystack'];

        if ($needle->count() == 0) {
            return true;
        }

        foreach ($needle as $object) {
            if (!$haystack->contains($object)) {
                return false;
            }
        }
        return true;
    }

}
