<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Contact;

use Internetgalerie\IgsCrm\Domain\Model\Contact;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;

//use TYPO3Fluid\Fluid\Core\ViewHelper\Traits\CompileWithContentArgumentAndRenderStatic;

class VerbandViewHelper extends AbstractViewHelper
{

    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    //\TYPO3Fluid\Fluid\Core\ViewHelper\AbstractTagBasedViewHelper {

    /**
     * Initialize arguments
     *
     * @api
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        $this->registerArgument('contact', Contact::class, 'Contact: Person/Organisation', true);
        $this->registerArgument('verband', \Internetgalerie\IgsCrm\Domain\Model\Verband::class, 'Verband', true);
        $this->registerArgument('as', 'string', 'contactVerband', false, 'contactVerband');
    }

    /**
     * Iterates through selected errors of the request.
     *
     * @return string Rendered string
     * @api
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $contact = $arguments['contact'];
        $verband = $arguments['verband'];
        //$templateVariableContainer=$this->renderingContext->getVariableProvider();
        $contactVerband = $contact->getContactVerbandById($verband->getUid());
        $templateVariableContainer=$renderingContext->getVariableProvider();
        $templateVariableContainer->add($arguments['as'], $contactVerband);
        $output = $renderChildrenClosure();
        $templateVariableContainer->remove($arguments['as']);
        return $output;
    }
}
