<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Format;

use Internetgalerie\IgsCrm\Domain\Model\Contact;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;

class TimeViewHelper extends AbstractViewHelper
{

    /**
     * Initialize arguments
     *
     * @api
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        //$this->registerArgument('value', 'string', 'source', true);
        $this->registerArgument('time', 'int', 'Zeit in Sekunden', false);
    }

    /**
     * Content Renderer
     * @return string
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        if (isset($arguments['time'])) {
            $time = (int)$arguments['time'];
        } else {
            $time = (int)$renderChildrenClosure();
        }
        $s = $time % 60;
        $timeM = ($time - $s)/60;
        $m = $timeM % 60;
        $h = ($timeM - $m) / 60;

        return sprintf('%d:%02d:%02d', $h, $m, $s);
    }
}