<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\FrontendUser;

use Internetgalerie\IgsCrm\Domain\Model\EntityWithAcl;
use Internetgalerie\IgsCrm\Utility\SecurityUtility;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3\CMS\Core\Database\ConnectionPool;

class UsernameViewHelper extends AbstractViewHelper
{

    protected static $cache = [];
    
    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        $this->registerArgument('uid', 'int', 'frontendUser uid', true);
    }

    /**
     * @param array $arguments
     * @param \Closure $renderChildrenClosure
     * @param RenderingContextInterface $renderingContext
     * @return bool
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    )
  {
      $uid = $arguments['uid'];
      if (!isset(static::$cache[$uid])) {
          $queryBuilder = GeneralUtility::makeInstance(ConnectionPool::class)->getQueryBuilderForTable('fe_users');
          $result = $queryBuilder->select('username')->from('fe_users')->where('uid=' . (int) $uid)->executeQuery();
          static::$cache[$uid] = $result->fetchOne();
      }
      return static::$cache[$uid];
  }

}