<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Hash;

use Internetgalerie\IgsCrm\Domain\Repository\ContactRepository;
use Internetgalerie\IgsCrm\Utility\SecurityUtility;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class UidYearViewHelper extends AbstractViewHelper
{
    protected $escapeOutput = false;
    public function initializeArguments()
    {
        $this->registerArgument('uid', 'int', 'contact uid', true);
        $this->registerArgument('year', 'int', 'year', true);
        $this->registerArgument('as', 'string', 'name for contact object ', true);
    }

    
    /**
     * @param array $arguments
     * @param \Closure $renderChildrenClosure
     * @param RenderingContextInterface $renderingContext
     * @return bool
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $uid = (int)$arguments['uid'];
        $year = (int)$arguments['year'];
        
        $validationHash = SecurityUtility::getUidYearHash($uid , $year);
        
        $templateVariableContainer=$renderingContext->getVariableProvider();
        $templateVariableContainer->add($arguments['as'], $validationHash);
    	$output = $renderChildrenClosure();
    	$templateVariableContainer->remove($arguments['as']);
        return $output;
    }

}
