<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Language;

use Internetgalerie\IgsCrm\Domain\Repository\LanguageRepository;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class ShowViewHelper extends AbstractViewHelper
{
    protected static $languages = null;

    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        $this->registerArgument('uid', 'int', 'language uid', true);
        $this->registerArgument('as', 'string', 'name for language object ', true);
    }
    /**
     * @param array $arguments
     * @param \Closure $renderChildrenClosure
     * @param RenderingContextInterface $renderingContext
     * @return bool
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $languageUid = $arguments['uid'];
        if (static::$languages === null) {
            static::$languages = [];
            $languageRepository = GeneralUtility::makeInstance(LanguageRepository::class);
            foreach ($languageRepository->findAll() as $language) {
                static::$languages[$language->getUid()] = $language;
            }
        }
        
        $language = static::$languages[$languageUid] ?? null;
        if ($language === null) {
            return '';
        }
        $templateVariableContainer=$renderingContext->getVariableProvider();
        $templateVariableContainer->add($arguments['as'], $language);
    	$output = $renderChildrenClosure();
    	$templateVariableContainer->remove($arguments['as']);
        return $output;
    }
}
