<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Link;

use Internetgalerie\IgsCrm\Domain\Model\Tag;
use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;

class SearchViewHelper extends AbstractViewHelper
{

    protected $escapeOutput = false;
    
    public function initializeArguments()
    {
        $this->registerArgument('as', 'string', 'The name of the iteration variable', true, 'search');
        $this->registerArgument('varband', 'int', 'tag', false);
        $this->registerArgument('tag', Tag::class, 'tag', false);
        $this->registerArgument('arguments', 'array', 'array', false, []);
    }

    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    )
    {
        $tag = $arguments['tag'] ?? null;
        if ($tag === null) {
            return '';
        }
        $search = array_merge($arguments['arguments'], [
            'tags' => [
                $tag->getTagverband()->getUid() => $tag
            ]
        ]);
        //var_dump($arguments['as'],$search);exit(0);
         
        $templateVariableContainer = $renderingContext->getVariableProvider();
        $templateVariableContainer->add($arguments['as'], $search);
    	$output = $renderChildrenClosure();
    	$templateVariableContainer->remove($arguments['as']);
    	return $output;
    }
}
