<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Membership;

use Internetgalerie\IgsCrm\Domain\Repository\MitgliedschaftRepository;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class ShowViewHelper extends AbstractViewHelper
{
    protected static $memberships = [];
    
    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        $this->registerArgument('uid', 'int', 'membership uid', true);
        $this->registerArgument('as', 'string', 'name for membership object ', true);
    }
    /**
     * @param array $arguments
     * @param \Closure $renderChildrenClosure
     * @param RenderingContextInterface $renderingContext
     * @return bool
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $membershipUid = $arguments['uid'];
        if (!isset(static::$memberships[$membershipUid])) {
            $membershipRepository = GeneralUtility::makeInstance(MitgliedschaftRepository::class);
            $membership = $membershipRepository->findByUid($membershipUid);
            static::$memberships[$membershipUid] = $membership;
        } else {
            $membership = static::$memberships[$membershipUid];
        }
        
        if ($membership === null) {
            return '';
        }
        $templateVariableContainer=$renderingContext->getVariableProvider();
        $templateVariableContainer->add($arguments['as'], $membership);
    	$output = $renderChildrenClosure();
    	$templateVariableContainer->remove($arguments['as']);
        return $output;
    }
}
