<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Organisation;

use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;

class CategoryExistsViewHelper extends AbstractViewHelper
{
    // falls HTML Tages erlaubt sind
    protected $escapeOutput = false;
    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        $this->registerArgument('organisation', 'object', 'Organisation', true);
        $this->registerArgument('category', 'object', 'categoryOrganisation', true);
        $this->registerArgument('as', 'string', 'Objeket ist zugänglich unter diesem Namen', false, 'cat');
    }
    /**
     * @param array $arguments
     * @param \Closure $renderChildrenClosure
     * @param RenderingContextInterface $renderingContext
     * @return bool
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $organisation=$arguments['organisation'];
        return $organisation->hasCategoryOrganisation($arguments['category']->getUid()) ?  $renderChildrenClosure() : '';
    }
}
