<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Organisation;

use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;


class FilialenAsTextViewHelper extends AbstractViewHelper
{
    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        $this->registerArgument('uid', 'int', 'organisation uid', true);
        $this->registerArgument('verband', 'int', 'verband uid', true);
        $this->registerArgument('as', 'string', 'name for organisation object ', true);
    }
    
    /**
     * @param array $arguments
     * @param \Closure $renderChildrenClosure
     * @param RenderingContextInterface $renderingContext
     * @return bool
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $organisationRepository = GeneralUtility::makeInstance(\Internetgalerie\IgsCrm\Domain\Repository\OrganisationRepository::class);
        $organisationUid = $arguments['uid'];
        $verbandUid = $arguments['verband'];
        $organisations = $organisationRepository->findRawFilialenActive($organisationUid, $verbandUid);
        $filialen = '';
        //$meficcFilialen = $this->getFilialen();
        foreach ($organisations as $f) {
            if ($filialen) {
                $filialen .= ', ';
            }
            $filialen .= $f['me_companyname'] . ' ' . $f['me_zip'] . ' ' . $f['me_city'];
            //$filialen .= $f->getMeCompanyname() . ' ' . $f->getMeZip() . ' ' . $f->getMeCity();
        }
        $templateVariableContainer=$renderingContext->getVariableProvider();
        $templateVariableContainer->add($arguments['as'], $filialen);
    	$output = $renderChildrenClosure();
    	$templateVariableContainer->remove($arguments['as']);
        return $output;
    }
}
