<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Person;

use Internetgalerie\IgsCrm\Domain\Repository\PersonRepository;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class ListViewHelper extends AbstractViewHelper
{
        /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        $this->registerArgument('frontendUserUid', 'int', 'frontendUser uid', true);
        $this->registerArgument('as', 'string', 'name for contact objects', true);
    }
    /**
     * @param array $arguments
     * @param \Closure $renderChildrenClosure
     * @param RenderingContextInterface $renderingContext
     * @return bool
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $personRepository = GeneralUtility::makeInstance(PersonRepository::class);
        $frontendUserUid = $arguments['frontendUserUid'];
        $contacts = $personRepository->findByFrontendUser($frontendUserUid);
        $templateVariableContainer=$renderingContext->getVariableProvider();
        $templateVariableContainer->add($arguments['as'], $contacts);
    	$output = $renderChildrenClosure();
    	$templateVariableContainer->remove($arguments['as']);
        return $output;
    }
}