<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Person;

use Internetgalerie\IgsCrm\Domain\Model\Contact;
use Internetgalerie\IgsCrm\Domain\Repository\TagRoleRepository;
use Internetgalerie\IgsCrm\Domain\Repository\ContactTagRepository;

use TYPO3\CMS\Core\Utility\GeneralUtility;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;

//use TYPO3Fluid\Fluid\Core\ViewHelper\Traits\CompileWithContentArgumentAndRenderStatic;

class RoleViewHelper extends AbstractViewHelper
{

    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    //\TYPO3Fluid\Fluid\Core\ViewHelper\AbstractTagBasedViewHelper {

    /**
     * Initialize arguments
     *
     * @api
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        $this->registerArgument('person', Contact::class, 'Person/Person', true);
        $this->registerArgument('tag', \Internetgalerie\IgsCrm\Domain\Model\Tag::class, 'Tag', true);
        $this->registerArgument('as', 'string', 'contactTag', false, 'contactTag');
    }

    public static $cacheTagRoles = null;
    
    /**
     * Iterates through selected errors of the request.
     *
     * @return string Rendered string
     * @api
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $person = $arguments['person'];
        $tag = $arguments['tag'];
        //$templateVariableContainer=$this->renderingContext->getVariableProvider();
        //$this->tagRepository->findByUid($searchTag);
        if (self::$cacheTagRoles === null) {
            $tagRoleRepository =  GeneralUtility::makeInstance(TagRoleRepository::class);
            $tagRoles = $tagRoleRepository->findByTag($tag);
            self::$cacheTagRoles = [];
            if ($tagRoles->count()) {
                foreach ($tagRoles as $tagRole) {
                    self::$cacheTagRoles[] = $tagRole->getUid();
                }
            }
        }
        $contactTagRepository =  GeneralUtility::makeInstance(ContactTagRepository::class);
        $contactTag = $contactTagRepository->findOneByContactTags($person, self::$cacheTagRoles);
        /*
        if ($person->getUId() ==435) {
            var_dump(self::$cacheTagRoles,$contactTag->getUid(), $contactTag->getTagRole()->getName());exit(0);
        }
        */
        $templateVariableContainer=$renderingContext->getVariableProvider();
        $templateVariableContainer->add($arguments['as'], $contactTag);
        $output = $renderChildrenClosure();
        $templateVariableContainer->remove($arguments['as']);
        return $output;
        //. '::as=' . $this->arguments['as'] .'('.$person->getUid(). ','. $verband->getUid().'='.( $contactVerband ? $contactVerband->getVerband()->getUid() : '').')';
    }
}
