<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Person;

use Internetgalerie\IgsCrm\Domain\Model\Contact;
use Internetgalerie\IgsCrm\Domain\Model\Verband;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;

//use TYPO3Fluid\Fluid\Core\ViewHelper\Traits\CompileWithContentArgumentAndRenderStatic;

class VerbandViewHelper extends AbstractViewHelper
{

    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    //\TYPO3Fluid\Fluid\Core\ViewHelper\AbstractTagBasedViewHelper {

    /**
     * Initialize arguments
     *
     * @api
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        $this->registerArgument('person', Contact::class, 'Contact: Person/Organisation', true);
        $this->registerArgument('verband', 'mixed', 'Verband', true);
        //$this->registerArgument('verband', Verband::class .'|int', 'Verband', true);
        $this->registerArgument('as', 'string', 'contactVerband', false, 'contactVerband');
    }

    /**
     * Iterates through selected errors of the request.
     *
     * @return string Rendered string
     * @api
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $person = $arguments['person'];
        $verband = $arguments['verband'];
        $verbandUid = is_object($verband) ? $verband->getUid() : (int) $verband;
        //$templateVariableContainer=$this->renderingContext->getVariableProvider();
        $contactVerband = $person->getContactVerbandById($verbandUid);
        $templateVariableContainer=$renderingContext->getVariableProvider();
        $templateVariableContainer->add($arguments['as'], $contactVerband);
        $output = $renderChildrenClosure();
        $templateVariableContainer->remove($arguments['as']);
        return $output;
        //. '::as=' . $this->arguments['as'] .'('.$person->getUid(). ','. $verband->getUid().'='.( $contactVerband ? $contactVerband->getVerband()->getUid() : '').')';
    }
}
