<?php
namespace Internetgalerie\IgsCrm\ViewHelpers;

use Internetgalerie\IgsCrm\Domain\Model\Contact;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;

class ReplaceTagsViewHelper extends AbstractViewHelper
{

    /**
     * Initialize arguments
     *
     * @api
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        //$this->registerArgument('value', 'string', 'source', true);
        $this->registerArgument('person', Contact::class, 'Person', false);
        $this->registerArgument('objects', 'array', 'array of Objects');
    }

    /**
     * Content Renderer
     * @return string
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $output = $renderChildrenClosure();
        //$html =$arguments['value'];
        $person = $arguments['person'];
        $objects = $arguments['objects'];
        $output= str_replace('[[person.titelName]]', $person->getTitelName() , $output);
        $output= str_replace('[[person.name]]', $person->getName() , $output);
        $output= str_replace('[[person.strasse]]', $person->getAddress() , $output);
        $output= str_replace('[[person.plzort]]', $person->getZip() . ' ' . $person->getCity(), $output);
        $output= str_replace('[[person.plz]]', $person->getZip(), $output);
        $output= str_replace('[[person.city]]', $person->getCity(), $output);

        return $output;
    }
}
