<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Verband;

use Internetgalerie\IgsCrm\Domain\Model\Verband;
use Internetgalerie\IgsCrm\Utility\SecurityUtility;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractConditionViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class IfHasAclViewViewHelper extends AbstractConditionViewHelper
{
    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        $this->registerArgument('verband', Verband::class, 'verband', true);
    }
   /**
     * This method decides if the condition is TRUE or FALSE. It can be overriden in extending viewhelpers
     * to adjust functionality.
     *
     * @param array $arguments ViewHelper arguments to evaluate the condition for this ViewHelper, allows for
     *                         flexiblity in overriding this method.
     * @return bool
     */
    protected static function evaluateCondition($arguments = null)
    {
        $verband = $arguments['verband'];
        if (!$verband instanceof Verband) {
            return false;
        }

        $securityUtility = GeneralUtility::makeInstance(SecurityUtility::class);

        return $securityUtility->aclHasRead($verband);
    }

}
