<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Verband;

use Internetgalerie\IgCrmTemplate\Domain\Repository\TemplateLetterRepository;
use Internetgalerie\IgsCrm\Domain\Model\Verband;
use Internetgalerie\IgsCrm\Utility\SecurityUtility;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractConditionViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class IfHasTemplateLetterViewHelper extends AbstractConditionViewHelper
{
    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        parent::initializeArguments();
        $this->registerArgument('client', Verband::class, 'verband', true);
        $this->registerArgument('objectType', 'string', 'objectType', false, null);
        $this->registerArgument('templateType', 'string', 'templateType', false, null);
    }
   /**
     * This method decides if the condition is TRUE or FALSE. It can be overriden in extending viewhelpers
     * to adjust functionality.
     *
     * @param array $arguments ViewHelper arguments to evaluate the condition for this ViewHelper, allows for
     *                         flexiblity in overriding this method.
     * @return bool
     */
    protected static function evaluateCondition($arguments = null)
    {
        $client = $arguments['client'];
        if (!$client instanceof Verband) {
            return false;
        }

        $templateType = $arguments['templateType'];
        $objectType = $arguments['objectType'];

        $templateLetterRepository = GeneralUtility::makeInstance(TemplateLetterRepository::class);

        $templateLetters = $templateLetterRepository->findByVerbandType($client->getUid(), $templateType, null, $objectType);
        return is_array($templateLetters) ? count($templateLetters) : false;
    }

}
