<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Verband;

use Internetgalerie\IgsCrm\Domain\Model\Contact;
use Internetgalerie\IgsCrm\Domain\Model\ContactVerband;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractConditionViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class IfIsMemberViewHelper extends AbstractConditionViewHelper
{
    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        $this->registerArgument('verband', 'int', 'verband uid', true);
        $this->registerArgument('person', Contact::class, 'Person/Person', true);
    }
    
   /**
     * This method decides if the condition is TRUE or FALSE. It can be overriden in extending viewhelpers
     * to adjust functionality.
     *
     * @param array $arguments ViewHelper arguments to evaluate the condition for this ViewHelper, allows for
     *                         flexiblity in overriding this method.
     * @return bool
     */
    protected static function evaluateCondition($arguments = null)
    {
        $person = $arguments['person'];
        $verbandUid = $arguments['verband']; // $verband->getUid()
        //$templateVariableContainer=$this->renderingContext->getVariableProvider();
        $contactVerband = $person->getContactVerbandById($verbandUid);
        return $contactVerband instanceof ContactVerband ? $contactVerband->getActive() : false;
    }
}
