<?php
namespace Internetgalerie\IgsCrm\ViewHelpers\Verband;

use Internetgalerie\IgCrmTemplate\Domain\Repository\TemplateLetterRepository;
use Internetgalerie\IgsCrm\Domain\Model\Verband;
use TYPO3Fluid\Fluid\Core\Rendering\RenderingContextInterface;
use TYPO3Fluid\Fluid\Core\ViewHelper\AbstractViewHelper;
use TYPO3\CMS\Core\Utility\GeneralUtility;

class TemplateLetterViewHelper extends AbstractViewHelper
{
    /**
     * As this ViewHelper renders HTML, the output must not be escaped.
     *
     * @var bool
     */
    protected $escapeOutput = false;

    /**
     * Initialize arguments.
     */
    public function initializeArguments()
    {
        $this->registerArgument('client', Verband::class, 'verband', true);
        $this->registerArgument('objectType', 'string', 'objectType', false, null);
        $this->registerArgument('templateType', 'string', 'templateType', false, null);
        $this->registerArgument('favorite', 'bool', 'favorite', false, null);
        $this->registerArgument('as', 'string', 'name for verband object ', true);
    }
    /**
     * @param array $arguments
     * @param \Closure $renderChildrenClosure
     * @param RenderingContextInterface $renderingContext
     * @return bool
     */
    public static function renderStatic(
        array $arguments,
        \Closure $renderChildrenClosure,
        RenderingContextInterface $renderingContext
    ) {
        $client = $arguments['client'];
        if (!$client instanceof Verband) {
            return false;
        }
        
        $templateType = $arguments['templateType'];
        $objectType = $arguments['objectType'];
        $favorite = $arguments['favorite'];
        
        $templateLetterRepository = GeneralUtility::makeInstance(TemplateLetterRepository::class);

        if ($favorite) {
            $templateLetters = $templateLetterRepository->findFavoritesByVerbandType($client->getUid(), $templateType, $objectType);
        } else {
            $templateLetters = $templateLetterRepository->findByVerbandType($client->getUid(), $templateType, null, $objectType);
        }
        
        $templateVariableContainer=$renderingContext->getVariableProvider();
        $templateVariableContainer->add($arguments['as'], $templateLetters);
    	$output = $renderChildrenClosure();
    	$templateVariableContainer->remove($arguments['as']);
        return $output;
    }
}
