<?php


call_user_func(function () {

    $newColumn = [
        'membership' => [
            'exclude' => true,
            'label' => 'LLL:EXT:igs_crm/Resources/Private/Language/locallang_db.xlf:tx_igfibu_domain_model_invoiceitem.membership',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'int'
            ]
        ],
        'journal' => [
            'exclude' => true,
            'label' => 'LLL:EXT:igs_crm/Resources/Private/Language/locallang_db.xlf:tx_igfibu_domain_model_invoiceitem.journal',
            'config' => [
                'type' => 'input',
                'size' => 30,
                'eval' => 'int'
            ]
        ],

    ];
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addTCAcolumns('tx_igfibu_domain_model_invoiceitem', $newColumn);


    // add new type (addToAllTCAtypes only works for existing types as  of TYPO3 11.5.19)
    $GLOBALS['TCA']['tx_igfibu_domain_model_invoiceitem']['types'][\Internetgalerie\IgsCrm\Domain\Model\InvoiceItemMembership::class] = ['showitem' => 'type'];
    $GLOBALS['TCA']['tx_igfibu_domain_model_invoiceitem']['types'][\Internetgalerie\IgsCrm\Domain\Model\InvoiceItemJournal::class] = ['showitem' => 'type'];
    
    // add field only to type InvoiceItemMembership
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes(
        'tx_igfibu_domain_model_invoiceitem',
        'membership, description, amount, tax_behavior, tax_rate, cost_center',
        \Internetgalerie\IgsCrm\Domain\Model\InvoiceItemMembership::class, // type to add
    );
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addToAllTCAtypes(
        'tx_igfibu_domain_model_invoiceitem',
        'journal, description, amount, tax_behavior, tax_rate, cost_center',
        \Internetgalerie\IgsCrm\Domain\Model\InvoiceItemJournal::class, // type to add
    );

    /**
     * also add type to pulldown in tx_igfibu_domain_model_costcenter.invoiceitem_types
     */

    // add type InvoiceItemMembership to type pulldown in backend
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addTcaSelectItem(
        'tx_igfibu_domain_model_invoiceitem',
        'type',
        ['LLL:EXT:igs_crm/Resources/Private/Language/locallang_db.xlf:tx_igfibu_domain_model_invoiceitem.membership', \Internetgalerie\IgsCrm\Domain\Model\InvoiceItemMembership::class]
    );
    // add type InvoiceItemMembership to type pulldown in backend
    \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addTcaSelectItem(
        'tx_igfibu_domain_model_invoiceitem',
        'type',
        ['LLL:EXT:igs_crm/Resources/Private/Language/locallang_db.xlf:tx_igfibu_domain_model_invoiceitem.journal', \Internetgalerie\IgsCrm\Domain\Model\InvoiceItemJournal::class]
    );

    
});
